1.8.10 patch 1 (sasha+Geoff Burling+Jan Fedak)
 o Numerous man page and usage fixes by Geoff Burling.
 o Fixed bug in DefaultGeometry handling where check for USPosition/Size
   should have been negated.
 o Fixed compilation bug in lib/parse.c
 o Fixed minor typho in afterstep man page.
 o Debugged background setting on multihead config. It apperas that
   asetroot cannot be run with -l if it is named other then asetroot.
   Otherwise background selection from the menu does not work.
 o Updated Clean to use ProcessModuleArgs. Added global var display_name
   that is set to --display argument value or env var $DISPLAY 's value.
   MOst modules must be updated to remove var with the same name from
   main().
 o Applied patch from Jan Fedak to add startup geometry to database
   parameters.
 o Applied patch from Jan Fedak to fix hotkeys in menus.
 o Applied patch to get AfterStep to change Icon when Title is changing.
   New feel option  - FollowTitleChanges in feel has to be used to enable
   this feature.
 o Fixed Tile's -h handling.
 o added support for maximization to not exceed screen size, while
   working with xinerama.
 o man pages fixes.
 o Fixed socket/pipes reading loops to not cause 100% CPU utilization
   under CYGWIN and in some cases even on Unix.
 o Fixed Menus pointer location handling to use coordinates from events
   and not abuse XQueryPointer. Otherwise menus were behaving strange
   whenever events were late due to one reason or others.

1.8.9 patch 1 (sasha)
 o Fix X libraries order, to have Xext preceed X11 - causes problems on
   some Solaris systems.
 o fixed two warnings related to time.h
 o commented out dependency checking to avoid problems for users with old
   compilers. It is not needed in stable series anyways.
 o Added functionality to WindowsDesk function. If second argument is
   10000 then first is relative desk number, instead of exact.
 o Implemented Xinerama support. When window is initially placed - it
   will be appropriately moved to not appear in between monitors, unless
   user requested geometry explicetely.
 o When Xinerama is active, and asetroot is requested to scale or pad
   background image to the screen size it will use size of the first head
   ( the one with origin of 0,0 ).
 o Implemented separate Feel, Look, Background and Init/Restart functions
   for different screens in multihead config with no Xinerama.
 o We now read $TMPDIR in order to locate /tmp directory, and falling back
   to /tmp if envvar is not set.
 o somewhat fixed Align and Pad fields in the Asetroot config parsing.

1.8.8 patch 1 (sasha+allanon)
 o installastheme.pl now uses the first screen depth reported by xdpyinfo
   instead of the last; this fixes problems with the look not updating on
   XFree86 4.x (allanon)
 o removed reference to xiterm from Wharf config file; wharf now tries to
   load aterm, and then xterm if that fails (allanon)
 o fix to mystyle drawing as applyed to empty menu drawing
 o removed config reading from the pipe - was causing some compile time
   problems and really was never needed.
 o updated README.nl
 o fixed configure to sheck if X11/xpm.h should be used or just xpm.h,
   updated as_xpm.c accordingly.

1.8.4 patch 4 (sasha)
 o Added -fPIC to the compilation flags when compiling with GCC so to allow
   for compilation on IA64 architecture( as sugested on AS MailingList).

1.8.4 patch 3 (sasha)
 o Removed lots of memory allocation code from lib/safemalloc.c. It was not
   used anyways, but was causing problems on some older compilers.
 o Fixed src/afterstep/module.c to use different name for the socket when
   compiled under MS Windows (CYGWIN).

1.8.4 patch 2 (sasha)
 o fixed bug in iconization of windows with shaped icons, that was causing
   some servers to crash.
 o fixed harmless bug in menu window creation code, that was causing error
   message on startup - trying to create window with width = 0

1.8.4 patch 1 (sasha)
 o fixed Audio to wait for delay only after sounds that has been played
   successfully
 o patched nasty bug in libasimage/mystyle_property.c so that None pixmap
   does not get checked.

1.8.0 patch 4 (sasha)
 o rewrote Audio. It now autodetects rplay via configure; external player
   command has been moved into configure too, only args can be specifyed in
   audio config. Two more built-in options added - builtin-cat to stream
   contents of the sound file directly to /dev/audio, and builtin-stdout
   to dump it to STDOUT.
 o fixed afterstep to assign screen = Scr.screen to fix garbled output on
   multiscreen
 o cosmetic change in startmenu to read Star Office suite instead of site
 o added default colors to Pager's BorderColor, GridColor and SelectionColor
 o changed socket to use /tmp instead of non-configurable

1.8.0 patch 3 (sasha)
 o Fixed extra line in .depend files causing make to fail
 o backported true transparency changes from 1.9 into pixmap.c

1.8.0 patch 2 (sasha+contrib)
 o fixed shaped icons. (contributed by Mark Phillips)
 o fixed Pager's window stacking order (backported from 1.9 )
 o removed screen from libraries  (backported from 1.9 )
 o fixed .depend  files to hopefully compile on dumb Solaris.

1.8.0 patch 1 (allanon+Myrlin+sasha)
 o fixed annoying XError messages when starting asetroot after previous
   asetroot was killed
 o added signal handlers to asetroot to correctly exit on afterstep exit
 o fixed minor memory leaks in asetroot occuring when changing backgrounds
 o fixed asetroot crashing when same background is used for several
   desktops
 o should fix multiplying asetroots while changing backgrounds,
   in both resident and run-once modes.
 o fixed man page concerning IconTitle (Myrlin)
 o fixed man page WRT BackMultiGradient modes 8 and 9
 o WinList: fixed segfault due to balloons
 o Pager: moved balloon_setup() after config parsing; now pays attention
   to BalloonBorderWidth and BalloonBorderColor; added step to balloon.h
   to make the calling order more obvious

1.7.172 patch 2 (mihm)
 o Changed Nop " " to Nop "" in the two a_nop files under start/ tree
 o fixed n-c/ dir feels to have CirculateWindowUp (vs old CirculateUp)
 o corrected typos in NEW and UPGRADE file (missing Theme/ on
   $HOME/GNUstep/Library/AfterStep/Desktop/<insert>.include)
 o low and behold, to the new stable!
 o **** this patch will not apply and sync the patched tree with the
	source tree - the resaon is, binary files have been included
	in the source tree!
   ****
1.7.172 patch 1 (allanon)
 o installation no longer halts if /usr/share/gnome/wm-properties or
   /usr/local/share/gnome/wm-properties exists but is not writable
 o balloons now have a ten second maximum time-to-live; they will auto
   close after ten seconds, even if the pointer has not left the trigger
   window
 o modified menu include to backslash-escape all non-alphanumeric chars
   in the pathname when the function is Exec; this should be completely
   transparent to the user
 o removed --enable-makemenus (NO_MAKESTARTMENU); this option's
   functionality no longer exists
 o added tools/testcompile.sh to test configure options easily
 o lots of fixes to make compilation options work; every single configure
   option now works (by itself) on my system, and ~1000 combinations also
   work with no warnings and no errors
 o Auto: REMOVED module, as it does not work as well as the equivalent AS
   function (AutoRaise)
 o Form: modified escaping rules to backslash-escape all non-alphanumeric
   characters, not just single quote, double quote, and backslash; this
   allows the theme creation form to correctly create themes whose names
   contain arbitrary characters

1.7.164 patch 8 (mihm)
 o (sasha) added Makefile adjustment to add gnome AfterStep.desktop file
 o created AfterStep.dektop file for gnome control center intergration
 o update base directory documentation
 o update man pages
 o replaced CirculateUp with ChangeWindowUp in all feel. files

1.7.164 patch 7 (allanon)
 o set more Cursors in all feels to avoid the default (skull & crossbones)
   cursor
 o Wharf: update subfolder transparency on background change
 o WinList: no longer delete balloons twice (this could cause crashes!)
 o WinList: general cleanup of memory usage

1.7.164 patch 6 (allanon)
 o correctly handle BGR mode and MSBFirst modes
 o WinList: free up more memory at exit when --enable-audit is on

1.7.164 patch 5 (sasha)
 o Fixed bug when if focused window is iconized or destroyed, Warp does
   not do anything;
 o Hopefully Fixed bug when colors are swapped while loading images
   on Solaris.

1.7.164 patch 4 (Pitr)
 o Fixed bug in Pager when it dies if clicked on desk title right after
   startink up;
 o Added check for shadink steps number, so not to go into infinite
   loop, DA !?
 o am thinkink asetroot must be startink good now and don't leavink windows
   behind;
 o removed --enable-makemenusonboot from configure;

1.7.164 patch 3 (allanon)
 o as_jpeg.c compiles with --with-jpeg=no
 o added include of Xutil.h in src/afterstep/configure.c, needed for
   the XSizeHints in afterstep.h
 o determine the location of perl in the configure script
 o updated menu tree and default Form config file to reflect theme.handler
   changes (see below)
 o theme.handler: makeastheme.pl now creates a tarfile version of the
   theme in themes/ instead of putting the theme files in a subdir of
   desktop/themes
 o theme.handler: installastheme.pl now takes either a theme name or a
   tarfile argument, and installs the tarfile as astheme.sh did
 o theme.handler: removed astheme.sh and asthemecreate.sh as they are no
   longer necessary

1.7.164 patch 2 (sasha)
 o Fixed bug in Pager when if window was shaded/iconized on Pager startup it
   would not be shown this way, until it is moved/resized.
 o Finally performed `make indent` - hence the big size of the patch.
  
1.7.164 patch 1 (sasha)
 o fixed size of the shaded windows with vertical titlebar, shown in Pager.
 o disallowed SHADE function on windows with no titlebar.  
 o fixed Segfaulting when titlebar button has no funtions and balloons are 
   enabled. 
 
1.7.142 patch 22 (mihm)
 o removed previous two patches (20 and 21)
 o included updated FAQ (as-faq-devel.2000-1-10)
 o moved to snapshot

1.7.142 patch 21 (allanon)
 o fixed astheme.sh (was broken in patch 20, oops!!)

1.7.142 patch 20 (allanon)
 o turn off titlebutton balloons before loading look file
 o EdgeResistance no longer affects windows being moved along a the 
   border of a screen unless there is another page to move to
 o fixed crash (due to titlebutton balloons) when a titlebar button has 
   a defined pixmap but no defined actions
 o added error message to audit code to complain when attempting to 
   free() a NULL pointer
 o astheme.sh: allows use of themes with "." in their names
 o Form: added check for unknown form name
 o Pager: no longer crashes when a desk title is clicked immediately 
   after startup
 o Wharf: restart-on-buttonpress of dead swallowed apps now works for 
   Wharf buttons which do not have an action

1.7.142 patch 19 (sasha) 
 o Fixed mode 128 in WinList, broken after previous patch
 o Fixed mode 128 inPager broken in prev patch
 o Fixed Pager update on look change for modes other then 
   transparent (129,130).
 
1.7.142 patch 18 (mihm+sasha)
 o fixed version number in AfterStep.spec and updated internal changelog
 o removed some of the old looks and associated pixmaps, as themes are
   the way of the future! :)
 o removed extraneous files that are created from .in files
 o (Sasha) changed x_pager.c; unused desk no longer shown
 o (Sasha) enabled mode 130 in Pager: (x_pager.c:GetMyStylePixmap()).
 o (Sasha) fixed old bug when transparent Pager won't become transparent 
   on startup in 50% cases: (x_pager.c:HandleExpose()).
 o (Sasha) fixed bug to update transparency on look change. 
   (Pager.c:ApplyLook()).
 o (Sasha) enabled mode 130 in WinList: 
   (WinList.c:update_winlist_background()).
 o (Sasha) added handling of removed MyStyle for WinList: 
   (WinList.c:update_look()).

1.7.142 patch 17 (sasha)
 o fixed window functions
 o fixed titlebarbutton balloon text .
 o added delay to asetroot AfterStep notification code - should work for now.
 o updated Pager to better show very large windows.  
 o fixed error in theme installer (ish).

1.7.142 patch 16 (allanon)
 o BACKED OUT PATCHES 9, 11, 12, 13, 14, and 15 in preparation for a 
   stable release
 o removed look.MacOS8 and associated pixmaps; it should be a theme 
   instead, but patch doesn't handle tarballs :)
 o added new .include option, "extension", to strip prefixes/suffixes 
   from included filenames; used option on Look/Feel menus
 o changed "include" and "command" .include options to allow arguments 
   to the AS command
 o QuickRestart("all") now updates the desktop background
 o added new QuickRestart target, "background", to update the desktop 
   background
 o theme-related changes:
   o added new menu, Desktop->Theme to contain themes
   o added new directory in share dir, themes, to contain themes
   o added form to create themes
   o theme.handler (makeastheme.pl, installastheme.pl, astheme.sh, 
     asthemecreate.sh) is now installed by make install

1.7.142 patch 15 (allanon)
 o AS_ASSERT now works with --enable-audit
 o included string.h in audit.c to fix compile-time warning
 o windows no longer "disappear" from other desks when restarting AS

1.7.142 patch 14 (allanon)
 o RandomPlacement works; titlebar geometry was not being set before 
   calling PlaceWindow()
 o fixed off-by-one error with shaped windows
 o TexturedHandle works again

1.7.142 patch 13 (sasha)
 o TitleButtonStyle now works as before patch 9. In addition 
   TitleButtonStyle 2, allows to specify exact offsets of the Titlebar 
   buttons from the edges of the titlebar ( see TitleButtonX/YOffset).
 o removed hi/lorcolor crap from configure - it's not used anyways and was
   allowing for buffer overrun bugs.   
 o removed unised flags XPM_ICON and something else .
 o removed TitleStyle stuff as it was not used.
 o when shading windows we no longer unmap/remap client window - 
   it was dangerous and useless anyways( suggested by allanon).
 o Titlebar is now a Parent of all title button windows. 
   ( it was main frame window before ).
 o Minor Cleanup of Iconify, DeIconify, HandleUnmapNotify, HandleMapNotify,
   MapIt, UnmapIt. The idea was to use MapIt and UnmapIt as much as possible.
   also removed unneeded SetBorder calls. That should fix aterm disappearing
   off the screen, at least I could not get it to disappear :).
 o Added AS_ASSERT macro to audit.c and audit.h. To facilitate better checking
   for NULL pointers passed as the function argument. Only a few functions
   changed to use it thou. We should use it as much as possible.
 
1.7.142 patch 12 (allanon)
 o shaped client windows work well again
 o changing images in xv no longer causes xv to "walk" across the screen

1.7.142 patch 11 (sasha)
 o Added RestoreWindow to borders.c to forcefully resize and update frame 
   even if size did not change.
 o Updated Shade(), Maximaze() to use this function.
 o Simplyfied Stick() to not redraw border hundred times.
 o rewrote DeIconify()
 o added flag DIRTY to indicate that configuration was changed while window
   was inocifyed and it needs to be resized when uniconifyed.
 o hopefully fixed gamma correction in PNG code.
 o All of that fixed bunch of bugs reported by David Mihm, and possibly 
   create a new :).
 
1.7.142 patch 10 (allanon)
 o added #include <string.h> in safemalloc.c to fix a compiler warning
   with --enable-audit
 o shaded windows obey AvoidCover
 o if Maximize'ing to a percentage of full-screen, use full-screen minus
   AvoidCover windows

1.7.142 patch 9 (sasha)
 o rewrite of borders.c frame window management code
 o cleanup of the  ASWindow structure
 o cleanup of the ScreenInfo structure
 o minor cleanup of AddWindow()
 o cleanup of LoadASConfig
 o minor fixes for Pager to beter handle very large windows - need more work
 o UpdateAll now also applies some stuff from database against existing 
   windows.
 o TitleButtonStyle now specifyes exact distance of the buttons from the 
   titlebar borders
 o frames cleanup
 o rewrite of titlebutton code
 o with vertical title sidebar now is on the side - not on the bottom
 o sidebar transparency gets updated correctly
 o No more double reparenting
 o More stuff that I don't remember :)
 o This Patch is dangerous - use it at your own risk !!!!!!!
 
1.7.142 patch 8 (sasha)
 o finally applyed fix for colors on Solaris and some other X servers 
   that use BGR instead og RGB. ( suggested from ML )
 o applied Tigr's module patch, converting AnimateCascade and Banner 
   to use new ASModule stuff.    
 o some more memory savings in menu processing code. dirtree now points
   to actuall function term, vs. having the copy of the text.
 o fixed bug when space in filenames will get mistreated in look,feel and
   background commands.
 o major cleanup of function execution code. ChangeWindowUp now does 
   cursor warping.
 o fixed PNG loading bug.
 o added Gamma correction to JPEG images. Value of gamma correction can be
   adjusted by SCREEN_GAMMA env var. Default gamma value changed to 1.0 from
   2.2.
 o minor improvements in JPEG loading code for colormapped images.
 o ascolor.h containing all rthe ASCLOR macros branched off stepgfx.h            
 o functions.h branched off parse.h and moved into src/afterstep
 o function codes are now enumerations vs. macros. Two functions where 
   added to obtain function definition term out of function text or code,
   to menuitem.c
 o fixed minor memory leak in asetroot
 o Pager now supports "*PagerDesk<desknum>" MyStyle definitions, which 
   duplicates functionality of *PagerDeskStyle option. *PagerDeskStyle 
   has higher priority. The reason for addition was to enable easy theme 
   creation. 
 o Fixed window moving in Pager so it allows to move window off the 
   screen, and when cursor goes off the Pager - desk will be changedfor 
   the window that is being moved.
 o man pages updated for Pager, asetroot and afterstep to reflect 
   changes. 
 
1.7.142 patch 7 (sasha)
 o type of the func_val members in Menu* structures changed back to long
   as it appears that it is used to store pointers and window ids in
   some functions. 
 o fixed windowlist to not add 1& in front of items
 o added support for more complicated syntax in parsing stuff    
   for things like: Function "name" another-name
 o fixed support for sign infront of the number in parse_func(). 

1.7.142 patch 6 (sasha)
 o afterstep/menuitem.c spawned from configure.c and module.c to include
   all menu and function parsing functionality.
 o all function parsing is now done by parse_func() instead of having 
   several different versions of the same code.
 o TermDef and hashing from lib/parser.c moved to lib/termhash.c to allow
   for better modularity when static libraries are used.
 o function parsing now using TermDef stuff to parse function and describe 
   function's syntax. (see menuitem.c)
 o menus.h moved from include/ to src/afterstep as it is only used in 
   afterstep. All the modules are modifyed respectevely.
 o menu parsing stuff is greately reworked, streamlined and simplyfied.
 o added CreateMenuItem, DeleteMenuItem, CreateRootMenu; 
   removed ParseMenuItem, added MenuItemFromFunc instead;
   removed AddToMenu as not needed.
 o MenuItem removed from MouseButton struct as it was not needed.
 o type of the func_val members in Menu* structures changed to short to save 
   up some memory, as it is not likely that we'll ever get screen dimentions
   as big as 32Kx32K       
 o FuncKeyRoot member of ScreenInfo changed to pointer.
 o windows.c updated to use new menu item handling stuff.
 o added string_from_int() to parse.c.
 o UloadImage,UnloadMask,mystrdup,mystrndup changed to enable tracking
   of where it was called from if need arises.
 o possible buffer overrun fixed in functions.c
 o tiny-winny memory leak in Pager fixed (in MovePage()).

*WARNING*
 o this patch can break some things due to vaste amount of changes.   
 o functions.c still needs some work as well as afterstep man page.

1.7.142 patch 5 (allanon)
 o set _WIN_DESK property on root on startup, and delete it when quitting 
   (not on restart); else InitFunction was being used on restart
 o Wharf: add extra check to make sure that swallowed windows get placed 
   properly

1.7.142 patch 4 (allanon)
 o added support for XFree, XGetWindowProperty, XQueryTree, XGetWMHints, 
   XGetWMProtocols, XGetWMName, XGetClassHint, XGetAtomName, and 
   XStringListToTextProperty to audit code
 o reworked the window desktop placement code; the following describes 
   how the new code should work:
     1. if sticky, use current desk
     2. _XA_WIN_DESK, if set
     3. if the client requested a specific desk on the command line, use that
     4. if part of a window group, same desk as another member of the group
     5. if a transient, same desk as parent
     6. use StartsOnDesk from database, if set
     7. the current desk
 o removed redundant SaveDesktopState() function
 o added note in afterstep man page mentioning requirements for using 
   transparency modes 129 and 130
 o iconified windows may now be shaped again, in much the same way that 
   Wharf buttons can be shaped; to get a completely transparent 
   background, use a completely transparent pixmap as the ButtonPixmap
 o removed redundant aswindow_get_size() function in favor of 
   get_window_geometry()
 o fixed MyStyle bug that would cause crashes when reading a style in a 
   module which had F_BACKTRANSPIXMAP set and not F_BACKPIXMAP (this is 
   an invariant violation, btw, and should never happen, but was 
   happening in rare cases involving MyStyle inheritance)
 o Wharf: if a swallowed window dies, Wharf waits for a click on the 
   button, then relaunches and swallows the app
 o Wharf: MaxSwallow'ing a 64x64 window puts the window in the right 
   place again

1.7.142 patch 3 (allanon)
 o fixed UnloadImage() and UnloadMask() to work properly when pixmap 
   reference counting is on
 o updated FAQ question on backgrounds to say that asetroot (not Pager) 
   controls the root background
 o icon title windows are placed properly when there is no corresponding 
   icon pixmap window
 o icons are generated when KeepIconWindows is off and an app provides 
   its own icon
 o Wharf: fixed ForceSize
 o Wharf: fixed bug that caused Wharf to place itself in a corner
 o Wharf: clicking on buttons works again (broken in patch 2 by me, not 
   tildouf; oops!!)
 o Jordi Mallach Perez <jmallac@bugs.eleinf.uv.es> updated README.es

1.7.142 patch 2 (tildouf)
 o bug fix for audio module, Delay is take into account now.
 o new feature for Wharf: transient. It allow a button to be
   not pushabled and no balloon is displayed with.
   Use: *Wharf Label pixmap transient.
 o TO DO: update the man page for Audio, since new events can be 
   associated with sounds in Audio config file.
   -> Sorry !

1.7.142 patch 1 (sasha)
 o fixed libasimage to compile when ther are no libpng or libjpg or libxpm
 o fixed warning in mystyle_property.c
 o removed startmenu.in from configure 

1.7.126 patch 16 (allanon+mihm+sasha)
 o added docs for SeparateButtonTitle and ButtonSize to NEW and man page
 o updated the looks for the new snapshot
 o fixes from sasha :) :
   fixed window placement code to correctly restore windows desks upon
   AS restart;
   fixed feel parsing code to correctly process +/- in command parameters;
 o adjusted README's for the removal of enable-iconbackground

1.7.126 patch 15 (sasha)
 o removed SetTransparency from AddWindow() as it gets called again from 
   SetupFrame.
 o allanon's bugfix in configure.c causing as to crash.
 o fixed forecolor being screwed up in modules.
 o config line cleanup from comments and whitespaces moved into 
   parse.c:stripcomments(char*).
 o added parse.c:parse_token() to extract space separeted tokens from 
   any config line.
 o rewrote mystrcasecmp() - it should be faster now, and checks for NULL 
   pointers.
 o fixed window moving in Pager so windows stays where you put them, when 
   releasing mouse button.
 o somemore cleanup in afterstep/configure.c  and afterstep/modules.c
   primarily in AS command parsing/processing code, it should also fix
   some bugs in menu parsing code from patch 12.
 o added log_call to audit.c to enable easy tracing of library calls.
   So far it is implemented only for load/unload_font(). but can be used
   on any function, if need arises.
 o added ifdef DONT_GRAB_SERVER to allow disabling of XGrabServer calls
   while debugging afterstep. 
 o removed ifneq/endif from makefiles to possibly fix compilation with 
   ANSI make. 
 
1.7.126 patch 14 (allanon)
 o removed --enable-iconbackground configure option (and the corresponding 
   define, NO_ICON_BACKGROUND), and replaced it with the following:
   o floating icon titles are now DISABLED by "SeparateButtonTitle 0" in 
     the look file; they are on by default
   o fixed-size icons may be specified by the ButtonSize option
   o icon background color/gradient/pixmap is set by ButtonPixmap MyStyle
 o no longer shape iconified windows at all; with icon backgrounds, 
   shaping doesn't make sense unless the background has a mask (which is 
   not yet allowed)
 o added four new MyStyles to handle iconified windows: ButtonPixmap, 
   ButtonTitleFocus, ButtonTitleSticky, ButtonTitleUnfocus; see NEW file 
   and afterstep man page for more details
 o rewrote half of icons.c :)
 o new property _WIN_DESK set on all client windows; this allows AS to 
   put windows back on the correct desk when restarting
 o fixed memory leak in fill_with_darkened_background(); thanks VERY MUCH 
   to sasha for doing most of the work to find this; mode 129 transparency 
   should no longer eat up memory in insane fashions
 o Wharf: ignore a second SIGPIPE while shutting down; this was (rarely) 
   causing segfaults
 o Wharf: AnimateDelay is now in milliseconds as the man page says, 
   instead of microseconds (oops)

1.7.126 patch 13 (sasha)
 o restored XGrabServer/XUngrabServer.
 o fixed bug in replaceEnvVar causing unpredictable results. 

1.7.126 patch 12 (sasha and allanon)
 o cleanup and rewrite of lib/homeanddirs.c and lib/findicon.c
   CreateDir moved into afterstep, added CopyFile.
 o somewhat simplifyed MakeMenus and changed it into LoadASConfig.
 o improved is_executable_in_path to cache serach information.
 o increased allocations limit to 30000 in memory audit code.
 o includes some changes from allanon - refresh of menu background,
   and LoadSAConfig improvements.
 o removed buffer overrun bugs in ParseMouseAction.
 o Cleaned up MeltMainMenu.

1.7.126 patch 11 (allanon)
 o added BackPixmap 130, which averages a pixmap and the root background; 
   see NEW and afterstep man page for details

1.7.126 patch 10 (sasha and allanon and Tigr)
 o New Pager mouse handling code: Windows movement fixed, page switching 
   now supports mose dragging. If mouse button released outside of the 
   Pager - movement gets canceled.
 o Hopefully fixed problems with color allocation on big endian systems
   (PUT_ASCOLOR macro in stepgfx.h)
 o Fixed bug in gradient drawing algorithm causing wrong gradients in 32bpp.
 o SendInfo moved from sendinfo.c to ASModule.c
 o Added DestroyASMessage to free up memory allocated for ASMessage
   (ASmodule.c)
 o Fixed blueish artifact problem in 16bpp (reported by Tigr).
 o Fixed compile problems when Icon background is used (allanon)
 o Fixed memory leak problem in Auto (Tigr)   
 o Fixed ChangeLog for patch 6 (Tigr)
   
1.7.126 patch 9 (sasha and allanon)
 o new gradient code!  features follow:
 o dithers (using a random dither) if necessary and possible, to improve 
   smoothness of gradients in less than 24bpp; this is actually faster 
   than the old method (sometimes much faster)
 o new truecolor gradient code looks much better when it can be used; 
   also much faster than the dithering technique above
 o multi-point gradients have been added to MyStyles; see NEW file and 
   afterstep man page for more information

1.7.126 patch 8 (allanon)
 o memory auditing code now keeps track of maximum total normal and X 
   memory allocations
 o Wharf: fixed problem with multiple rows/columns when the number of 
   buttons is not evenly divisible by the rows (or columns)

1.7.126 patch 7 (tildouf and allanon)
 o icon title background is now the same as the titlebar background, 
   except that tinted transparency is just transparent (not tinted)

1.7.126 patch 6 (Tigr)
 o Animate: now uses aslib module code
 o Auto: now uses aslib module code
 o Audio: now uses aslib module code

1.7.126 patch 5 (Jan Fedak <J.Fedak@sh.cvut.cz>)
 o fixes menu keyboard shortcuts

1.7.126 patch 4 (allanon)
 o shading is no longer reset when restarting, and windows will be 
   re-shaded after restart

1.7.126 patch 3 (allanon)
 o added new define for AfterStep-specific library dependencies in 
   Makefiles; was getting "No rule to make `-ljpeg'." before
 o removed suggestion to use 'Wait "I" asetroot' from autoexec; since 
   asetroot doesn't make a window, this would cause afterstep to hang
 o fixed call to asetroot in RestartFunction

1.7.126 patch 2 (allanon)
 o iconified windows are no longer treated as open while moving around an 
   AvoidCover window
 o moved Tigr's iconified windows patch; ICONIFIED should take precedence 
   over SHADED
 o module socket is now mode 0700 for better security

1.7.126 patch 1 (sasha)
 o CheckASMessage changed to CheckASMessageFine, allowing for timeouts 
   of milliseconds. CheckASMessage is now macro calling this function.
 o added check for endiannes, and respective byte swapping code in XImage
   access macros in stepgfx.h. That should produce correct colors in > 8bpp 
   on SUN.
 o added make dep; target, that should produce dependancy list in .depend 
   file, that gets included in Makefile and allows fopr atomagical 
   recompilation in headers or libraries has changed.
 o Minor cleanup in most of the modules, removing includes for broken sun
   headers - it is not used anyways.

1.7.111 patch 15 (sasha+Tigr)
 o applyed Tigr's patch for better handling of iconifyed windows with no 
   icon associated with them.
 o Fixed bug in asetroot, causing it not to change background if you just 
   started it and have not had a chance to change current desk yet.
   Reported by Tigr.
 o Added importasmenu script in to tools dir, to help GNOME and KDE users
   import their menus into AfterStep menu.
 o Completed base gradients code, now MyStyles code and other stuff needs
   to be converted to use it, and old code needs to be dropped.
   New code has same size as old one, works twice as fast when dithering 
   is not needed, and allows for 8 different gradients and 2 modes (
   ditheringand no dithering ).

1.7.111 patch 14 (sasha)
 o Fixed Pager to reload root backgrounds only if current desk is serviced
   by this instance of Pager.
 o Fixed several bugs in asetroot causing all sorts of trouble while 
   changing backgrounds.
 o Fixed bug in asetroot when Wait would never detect asetroot -k.
 o Fixed autoexec file for asetroot.
 o added code for diagonal gradients. Still it's not yet connected to the
   main code, as it needs more work.
 o added src/test to configure, so that Makefile gets created.  

1.7.111 patch 13 (sasha)
 o Fixed bug in WinList causing corrupted background when transprency is 
   used.
 o Fixed bug in MyAllocColor causing it to wrongfully allocate colors
   in depth higher 24bpp (red component in particular ).
 o Added code to work on color as a single 32bit value (ASCOLOR), vs. 3 8 bit 
   components. That allows for most operations (sum, averaging, etc. ) to
   be done as single arithmetic operation combined with masking of unused
   bits. In particular it allows to get rid of all the floating point 
   calculations in gradient drawing, resulting in 100% improvements in speed.
 o Completely rewrote color allocation functionality to employ new ASCOLOR
   technique.
 o Changed code for image loading from file, to employ new ASCOLOR technique. 
 o Implemented Gradient drawing with dithering, utilizing ASCOLOR technique.
   ( Diagonal gradients are yet to be done ). It is using old drawing 
   techinque, when there are enough colors available and dithering is not
   needed. As dithering is about 10 times slower as conventional gradient
   drawing (still yelding satisfying performance thou). Additional parameter
   was added to gradient drawing function - finess. It sagnificantly speeds 
   things up, allowing for only several lines of gradient to be calculated,
   vs. every single line. It could one of the several things :
   - finess = -1 - default finess of  20 is used.
   - finess = 0  - highes quality of gradient
   - finess > 0  - defines number of lines that needs to be calculated and then 
     repeated with finess period. It is always limited to the length of the 
     gradient. 
 o Mentioned gradient drawing stuff was not yet used anywhere else, as I think,
   it needs some more testing on different architectures and color depthes, 
   and diagonal gradients are yet to be done.
 o src/test directory added to provide with ready to use general purpose 
   code for testing of the development stuff. I think it'd be good to keep it
   at least untill stable release, as it is not taking alot of space, and is not 
   compiled by default. Right now it is used for gradients testing.
 
1.7.111 patch 12 (allanon)
 o AutoReverse no longer ignores windows with both NoTitle and NoHandles; 
   instead it ignores windows with WindowListSkip or NoFocus
 o xv windows should no longer creep upward while looking through the 
   list of loaded images (oops!)
 o Wharf: left-clicking the withdrawn wharf when the top button is a 
   folder now works as expected; ie, the wharf remains withdrawn, and 
   the folder is opened; un-withdrawing wharf closes the folder if 
   necesary

1.7.111 patch 11 (sasha)
 o completed asetroot
 o removed background loading from Pager
 o fixed --disable-pagerbackground 
 o updated man pages for asetroot and Pager
 o fixes to lib/ASModule.c
 o made pixmap caching in libasimage optional -it's turned off in asetroot
 o updated WinList to use new module stuff
 o updated Zharf to use new module stuff, and support JPEG and PNG.
 o partly fixed balloons in Zharf - need to add code to actually 
   attach /detach balloons to buttons.
 o updated config files pager.in, asetroot.in, autoexec.in.
 
 It is expected that things will stop working after all that.
 
1.7.111 patch 10 (sasha)
 o added lib/asproperty.c for general X property reading/writing.
   include/asproperty.h - header for it.
   mystyle_property.c changed accordingly.
 o completed asetroot to set X property with information about all 
   root backgrounds loaded. Now it's time to remove background stuff
   from Pager.
 o implemented temporary memory storage to prevent memory fragmentation
   tests with asetroot did not show any improvements.May need some more 
   researching - posibly can improve memory consumption while loading 
   small images.
 o simplifyed stuff in module.h

1.7.111 patch 9 (allanon)
 o change desks before placing new windows, allowing interactive placement 
   to work better

1.7.111 patch 8 (allanon)
 o fixed ConfigureNotify event handling; xv windows no longer creep down 
   and across the screen
 o SmartPlacement + StartsOnDesk now works
 o WinList: added check for negative width/height before making pixmap

1.7.111 patch 7 ( sasha )
 o rewritten asetroot to provide for richer background configuration options.
 o afterstep/asetroot sample config updtaed accordingly and has some description
   of new config options.
 o asetroot config changed to use unifyed parser. ASetRoot.c added to 
   src/Config
 o added include/background.h to provide with set of root background 
   functionality that can be used in other modules/apps from libasimage.
   It is planned to implement backgrounds info storage in X property
   (single), similar to MyStyles. So it can be accesses from several 
   modules/apps. When it's done src/asetroot/background.c will be moved
   into libasimage.
 o Functionality to parse module command line, init X connection, init 
   AfterStep connection, construct coinfig file name and load config,
   X and AS image checking was moved into libafterstep, to eliminate
   duplicate code in modules. lib/module.c split into lib/ASmodule.c
   (holding basic functionality without X connection) and lib/Xmodule.c
   additional functionality to be used by modules that use X.
   All the modules will need to be modifyed accordingly if this change 
   will be agreed by development team.
 o added CheckASMessage function to enable AfterStep message checking  
   to skip duplicate messages. 
 TODO :
 o Enable backgrounds info storage as X property
 o Remove background loading from Pager, leaving optional background 
   switching functionality.
 o Update asetroot man page
 o Update every module to use new libafterstep functionality.
 
1.7.111 patch 6 (various people)
 o make install.data now removes .include.in files from the installed 
   start/ tree (Frederick Bruckman <fb@enteract.com>)
 o one or three pixel high Wharf-style gradients should no longer cause a 
   crash (allanon)
 o the lowbar corners are now in the frame context, as the afterstep man 
   page claims (allanon)
 o afterstep now pays attention to the window field of commands sent from 
   a module (Frederick Bruckman <fb@enteract.com>)
 o Audio: now plays correct sounds for events, including startup and 
   shutdown (tildouf)

1.7.111 patch 5 (allanon)
 o changed "cp -R" to "cp -r"; solaris 2.3's cp doesn't have the -R option
 o changed check for STDC_HEADERS to _SC_OPEN_MAX in GetFdWidth; solaris 
   2.3 doesn't define STDC_HEADERS, and doesn't have getdtablesize()
 o fixed crash when a menu item name is null (eg, Exec "" echo)
 o module pipes are now non-blocking all the time
 o HandleModuleInput() now keeps a buffer of input from a given module 
   until a command is complete
 o rewrote AutoReverse (0 and 1), and Circulate(); WarpFore no longer 
   hangs AfterStep when CirculateSkipIcons is set, all windows are 
   iconified, and an icon has focus
 o fixed icon placement bug; xv window's full size was being used for 
   determining placement

1.7.111 patch 4 (sashav)
 o fixed bug in Pager causing it not to update background when selected
   from the menu.
 o if Pager crashes for you with this patch please send me your pager 
   config file !!!
 o more logical data structures are now used in parser.
 o added functionality to the parser so it can now automagically handle
   nested constructs, like MyStyle or PagerDecoration. It can now handle
   unlimited number of nested semantics. FreeStorage now is tree like
   structure vs. linear.
 o added flag for atomagical handling of config terminating term, such
   as ~MyStyle.
 o changed Pager's and MyStyles parsing code accordingly. 

1.7.111 patch 3 (tildouf)
 o fixed frame keywords, NE, NW, SE, SW are more clear, in 
   afterstep.man, configure.c and look.nek

1.7.111 patch 2 (allanon)                                                
 o makeasversion: now updates AfterStep.spec version
 o heard from Faical Tanarhte <faycal@anrt.net.ma>, so removed the "NO   
   NEWS OF" from the TEAM file                                           
 o fixed bug that confused Pager into believing that windows were being  
   iconified when changing views
 o added check for negative file descriptors when setting non-blocking I/O

1.7.111 patch 1 (allanon)
 o made sure non-blocking I/O is off for module sockets, unless writing 
   to them; this may help on *BSD systems?
 o fixed frame keywords in afterstep.man (oops!)
 o fixed (hopefully) frame pixmap positioning; if it's wrong, i'm sure 
   tildouf will tell me :)
 o fixed vertical titlebar text positioning when the text is truncated

1.7.90 patch 21 (sasha+mihm)
 o fixed WinList positioning when South/East gravity is desired.
 o fixed WinList HideGeometry. WinList will display nice little 
   AfterStep version when there are no windows.
 o fixed WinList moving for South/East gravity and HideGeometry. 
 o included AfterStep.spec and redhat start/ directory for creation
   of rpm's by using the tarball.
 o modifications to various README files to explain rpm creation 
   process. 

1.7.90 patch 20 (allanon)
 o fixed crash when DecorateFrames is set, but no frame pixmaps are defined
 o fixed window positioning code WRT frames
 o got a little closer to updating frames properly on QuickRestart(look); 
   still need to add/remove frames when value of DecorateFrames changes
 o added documentation to afterstep.man for DecorateFrames, et al

1.7.90 patch 19 (allanon)
 o windows are now moved even if only the icon is showing; this fixes a 
   problem with !StickyIcons + StubbornIcons

1.7.90 patch 18 (makoto)
 o updated README.jp
 o fixed compilation problems in misc.c with I18N
 o fixed fontheight
 o Ident: fixed I18N code

1.7.90 patch 17 (allanon)
 o added pixmap reference counting; this reduces the time/memory used by 
   often-loaded pixmaps (such pixmaps are now loaded only once)
 o added note to afterstep.man mentioning the default Maximize options
 o removed non-configurable/startmenu; this file is no longer parsed; 
   instead, the start directory is always melted

1.7.90 patch 16 (allanon)
 o Animate: removed hanging else
 o Pager: replaced alloca() with safemalloc()
 o Wharf: added new option, WithdrawStyle, to tell Wharf where to grab 
   mouse button 3; 0 == never, 1 == all toplevel buttons, 2 == top/bottom 
   buttons (or left/right, for horizontal Wharfs) 

1.7.90 patch 15 (nekked)
 o changed frames to windows
 o fixes for WinList geometry
 o cursors can now be used with frames, see feel.nek for examples

1.7.90 patch 14 (nekked)
 o option added ShadeAnimationSteps #, as the name suggests it's the number
   of resizes performed on a window when (un)shaded.
 o some changes for delt's wmaker outline RubberBand, it takes vertical
   titlebars and frames into account as well
 o fix for frames and vertical titlebars
 o title text will no longer show underneath buttons
 o fixes for the minsize hint which wasn't properly interpreted by AfterStep,
   now applications that specify MinSize cannot be made smaller.

1.7.90 patch 13 (delt)
 o Fixed another minor drawing bug in Wharf, now all texture types
   should look OK when pushed with no border
 o Fixed Wharf folder position with MaxSwallow of non-modules
 o Optimized repeated code in resize.c, slightly more modular
   approach
 o Added 6 new rubberband effects: wmaker, tek, tek2, corners,
   hash, grid.
 o Changed a few function headers, so that some of the previous
   can be possible, ie. MoveOutline () needs a pointer to the
   ASWindow being moved/resized, etc. Changed all calls to these
   functions appropriately - move.c, resize.c, pager.c, events.c

1.7.90 patch 12 (nekked)
 o new options added
 o Look file:
     DecorateFrames 0|1 - turns the lowbar off and turns window frames on
     FrameNorth image - image for the topmost part of the border
     FrameSouth image - bottom border
     FrameWest image - left border
     FrameEast image - right border
     FrameTL image - top left corner
     FrameTR image - top right corner
     FrameBL image - bottom left corner
     FrameBR image - bottom right corner
 o Feel file:
    CustomCursor number bitmap mask - specifies custom cursor,
      refer to the feel file to see what the number is, bitmap is
      a depth 1 pixmap and so is the mask, examples are included
      in afterstep/desktop/cursors.  Cursors and masks are expected
      to be located in CursorPath.
 o Base.#bpp files:
    CursorPath - specifies the path where cursors are located, the
     default paths are /usr/local/share/afterstep/desktop/cursors and
     ~/GNUstep/Library/AfterStep/desktop/cursors
 o included look.nek and feel.nek that demonstrate these.
 o included cursors (taken from an E theme, ugh)
 o included pixmaps for look.nek
 o added database.nek that demonstrates how I think it should be set up
   for framed looks
 o small fix for alt-tab
 o a fix for a bug in Gnome that caused it to segfault on occasion
 o fixed a compilation warning in Gnome when --enable-audit not given to
   configure

1.7.90 patch 11 (allanon)
 o added to description of IconBox in afterstep man page
 o ascommand.pl: now version 1.2, and accepts two new options:
 o ascommand.pl: new option --file; reads commands from file
 o ascommand.pl: new option --interactive; reads commands from stdin, 
   prompting the user

1.7.90 patch 10 (allanon)
 o asimagelib: no longer crop images to screen size when loading
 o asimagelib: added accurate, but extremely slow, scaling algorithm; 
   it is commented out pending optimization and generalization to non-
   16bpp truecolor modes
 o initialize have_xpm_write to 0 in configure script; fixes builds on 
   systems without libXpm
 o added README.id (Indonesian); a big thanks to Mohammad Nafiri 
   <fiean@hotmail.com>
 o maximize function now defaults to 100 100 instead of 0 0

1.7.90 patch 9 (allanon)
 o Wharf: fixed folder positioning when MaxSwallow is used
 o Zharf: removed extra fopen()'s
 o added failsafe to prevent obscure crash while restacking windows
 o fixed stupid mistake (mine) which prevented SmartPlacement from 
   working as advertised WRT placing over StaysOnBack windows

1.7.90 patch 8 (sasha)
 o fixed WinList broken in patch 7
 o added some more parsing code documentation : doc/code/config_issues.html
 o fixed README versioning 
	
1.7.90 patch 7 (fuf)
 o fixed reading undefined variables in several files in the source tree
 o improved WinList stability by changing send_as_mesg()
 o misc little fixes

1.7.90 patch 6 (sasha)
 o mystyle_process_definitions moved into src/Config/MyStyle.c
   to solve compilation problems caused by previous patch.
   It was renamed to ProcessMyStyleDefinitions to suit style of that file.
 o declaration of  mystyle_process_definitions removed from mystyle.h
 o ProcessMyStyleDefinitions added to confdefs.h as it makes more sense.
 o minor fixes to parser code and MyStyles.c code to prevent warnings in 
   egcs.
 
1.7.90 patch 5 (sasha)
 o Several bugfixes and improvements in parser code.
   It now reports statement read from config file as public
   (non executable specific), private, enabled, disabled and/or
   foreign(belonging to other executable.
   Accordingly writer can treat file in desired way - like leave 
   only global statemets, leave comments, etc...
 o added MyStyle parsing code using parser. It now can be incorporated
   into any module.
 o Possible this new stuff has bugs as I did not have enough time to test
  it well( I'm getting a new PC ), they should not affect anything other 
  then Pager. I apologize for any inconvinience.

1.7.90 patch 4 (allanon)
 o added description of PutOnTop, PutOnBack, SetLayer to afterstep.man
 o changed AutoRaise code back to signal(SIGALRM); it's much uglier, but 
   a bug in glibc-2.0.7 causes segfaults with the timer implementation
 o (nekked) enabled DecorateTransients and disabled PagingDefault in 
   feel.GNOME
 o (nekked) Gnome: disabled debug output
 o (nekked) Gnome: fixed memory leak
 o (nekked) Gnome: fixed bug that caused internal error messages when 
   window count was 0

1.7.90 patch 3 (nyt)
 o added new function, ToggleLayer, to toggle a window between layers
 o updated move-or-top function in feels
 o added description of ToggleLayer to NEW and afterstep man page

1.7.90 patch 2 (allanon)
 o balloon code now uses MyStyle's for text/background config (note that 
   texture type != 0 does not yet work)
 o added titlebutton balloon help
 o moved balloon from libafterstep to libasimage to allow MyStyle config
 o added mystyle_get_text_geometry() to simplify getting the width and 
   height of MyStyle'd multi-line text
 o mystyle_draw_text() now obeys newlines in the text to be drawn
 o added support for malloc() to audit code
 o added more documentation for Include to afterstep.man
 o updated pager, wharf, winlist, zharf, and all looks to reflect changes
 o AutoRaise is now handled by the timer code
 o Gnome: replaced snprintf() with strcpy(); snprintf() is not portable
 o Pager: now uses style "*PagerBalloon" for balloons
 o Wharf: now uses style "*WharfBalloon" for balloons
 o WinList: now uses style "*WinListBalloon" for balloons
 o Zharf: removed balloons (they would require adding style support)

1.7.90 patch 1 (nekked)
 o added more flags to Ident, avoid cover, skipfocus, shaded, maximized,
   windowlistskip, circulateskip, transient and a check if AS is running
   with Gnome enabled
 o removed the annoying alarmalarm debugging fprintf from WinList
 o Gnome handles the DOCK layer properly now
 o checks for window id None that we sometimes receive from AS, this caused
   Internal error messages
 o comments added to Gnome, described function calls etc.
 o some changes to feel.GNOME, NoPPosition is off now like it should be

1.7.75 patch 15 (nekked)
 o added NOFOCUS flags to SET_FLAGS
 o fixed STICKY in Gnome
 o workspace requests now properly followed
 o updated feel.GNOME
 o bugfixes for the Gnome module (flag handling, configure events)
 o updated modules.c to generate configure events for all flags when
   SET_FLAGS called

1.7.75 patch 14 (nekked)
 o improved WinList's clock, the select now times out only when WinList
   is hidden
 o WinLists list of windows gets properly updated now when SET_FLAGS +
   WINDOWLISTSKIP is called
 o modified afterstep to allow for gnome proxy button events to occur
   (gnome.c)
 o added AVOID_COVER to SET_FLAGS
 o Gnome - initial hints are read properly from apps that set them
 o added support for gnome virtual paging
 o more gnome hints are supported, skip windowlist, skip menu, avoid cover
 o updated the Gnome man page
 o added feel.GNOME
 o gnome logo added to icons

1.7.75 patch 13 (sasha)
 o fixed bug in Pager that would not let it remove sticky windows off
   the desk, if desk is changed to outside of Pager's limits.
 o fixed Pager segfaulting when no label is specifyed in config
 o some improvements to parser code
 o new code for writing configuration back to file ( or memory buffer ) 
   Config writes is capable of preserving comments and, possibly
   unknown options. That can be disabled at runtime if needed.
 o options in config files can be temporary disabled and still remain 
   readable for parser, by embedding "#~~DISABLED~~# signature somewhere 
   in option parameters.
 o I sure hope I've got all the elements of config reading/writing in 
   place by now. But minor improvements are yet to be made, like:
   - better handling of options belonging to other executables.
   - better handling of disabled options ( possible move disable signature
     in front of option to make config compatible with older AfterStep 
     versions.
   - more options for writing config. 
   - more datatypes supported.
 o added WritePagerOptions to src/Config/Pager.c for writing Pager's 
   options to file.

1.7.75 patch 12 (allanon)
 o added new module-only function, SET_FLAGS; SET_FLAGS changes AS's 
   internal flags for a window; USE WITH CAUTION!! the internal flags 
   are NOT guaranteed to continue to exist, much less stay the same as 
   they are; basically, only AS modules (which can use the defines in 
   module.h) should use this function
 o ascommand.pl can now be passed several command line options (including 
   --help and --version); one of these is --window-id, which sets the 
   window id passed to AfterStep

1.7.75 patch 11 (nekked)
 o more GNOME stuff
 o fixes for WinList, it would crash when a button was clicked on, gradients
   would show with hide width and height.
 
1.7.75 patch 10 (allanon)
 o icons get placed in too-small IconBoxes again (was broken in patch 6)
 o if an iconbox is closer to the right edge of the screen than the left, 
   it will be scanned from right to left for an open space; similarly 
   for an iconbox which is closer to the bottom than the top
 o if an icon overflows the iconbox, and the iconbox is closer to the 
   right edge than the left, the icon will align with the right edge of 
   the iconbox; same for bottom
 o Gnome: replaced snprintf() with strcpy() and strncpy(); snprintf() is 
   not portable; hopefully this works (I don't have Gnome) :)
 o WinList: replaced snprintf() with strncpy()

1.7.75 patch 9 (sasha)
 o Fixed Pager's transparency, broken in patch 06.
 o Fixed WinList placement code - for any gravity now. 
  
1.7.75 patch 8 (Makoto Kato <m_kato@ga2.so-net.ne.jp>)
 o fixed mystyle property of asimagelib since WinList and Pager always
   crash with I18N

1.7.75 patch 7 (allanon)
 o the environment variable DESTDIR is prepended to all paths while 
   installing (for Red Hat)
 o Wharf: fixed Wharf geometry (oops!); thanks to ish for noticing

1.7.75 patch 6 (allanon)
 o added new configure option, --enable-warn, which turns on lots of 
   extra gcc warnings (list of warnings taken from rxvt)
 o added prototypes for put_png_scanline() and LoadPNGFile() to as_png.c
 o fixed prototypes for Reborder, SaveWindowsOpened, SetCirculateSequence
 o changed some library functions to use the same parameter types as 
   the libc functions they call
 o Broadcast() and SendPacket() now use the varargs facility, allowing a 
   variable number of arguments; note, however, that this means type 
   casting to unsigned int is no longer optional when passing anything 
   except int, signed int, or unsigned int (or a typedef thereof)
 o rewrote replaceEnvVar() to handle shell variables of the form ${VAR}
 o removed redundant function SendText(); SendInfo() is exactly the same
 o Wharf: strip spaces after Geometry specification if necessary; was 
   causing Wharf to show up in random places
 o remove borders from bottom to top in Reborder(); restarting AS should 
   no longer reverse the window stacking order
 o use XMoveResizeWindow instead of XMoveWindow on the client window in 
   SetupBorder; the window was placed wrong if the win_gravity wasn't 
   NorthWestGravity
 o tried to optimize view changes somewhat; see note in MoveViewport()
 o added get_window_geometry() to make determining window size (normal, 
   shaded, iconized) easy
 o rewrote AutoPlace() and SmartPlacement() to use get_window_geometry()

1.7.75 patch 5 (sasha)
 o Fixed few bugs in parsing code causing segfaults.
 o Fixed bug in Pager causing it to not display root background on startup.
 o Fixed bug in WinList causing it to get wierd size on look changes.
 o Fixed bug in WinList causing it to not display background on startup.    
 o added base.bpp file parsing definition and functions to src/Config.
 o converted Pager to use those ^^^.
 o started writing Developer's guide for parsing code - it is usable already
   see: doc/code/parser_devel_guide.html   

1.7.75 patch 4 (sasha)
 o Fixed bug in parser.h causing Pager to segfault just after startup
   in some cases.
 o Fixed WinList hiding code.
 o Fixed WinList placement code. 
   Note: afterstep is not placing windows correctly - windows are placed
   at x+2,y+2 if without titlebar, or x,y-8 if with titlebar.

1.7.75 patch 3 (sasha)
 o Changed WinList LeftJustify option to Justify <left|center|right>
 o Fixed WinList man page
 o Fixed ( hopefully ) WinList placement code - so winlist no longer 
   floats away  
 o fixed WinList segfaulting when it's vertical and no MaxWidth specifyed
 
1.7.75 patch 2 (nekked)
 o more GNOME hints supported
 o fixes for what was broken in Gnome
 o man page for Gnome
 o added entries for GNOME panel and gmc to database
 o removed the TODO file
 o config file for GNOME desks

1.7.75 patch 1 (sasha)
 o fixed bug in WinList causing it to segfault on startup if there are no 
   windows to show.
 o fixed asetroot image loading to load with better quality (nekked)   
 o finalized parsing code :
   Parsing is done in 3 steps :
   1. parsing source data from file or memory buffer in to the 
      "Free Storage" (suggested by allanon), in which it is stored as a 
      list of combinations of term definition reference and actual data 
      This is done by code in parcer.c.
   2. Free Storage is then processed by module specific function to extract 
      actual usefull data and store it in the module-specific structure
      This is done by code in src/Config/Modulename.c
   3. Module-specific config structure is then processed by module itself
      to initialize it's global variables, and get's deallocated by module
      as needed. 
 o parser.c moved to lib to make it available for other modules
 o parser.h moved to include 
 o created src/Config to hold all the module specific configuration 
   definitions and methods.
 o Moved Pager to use new unifyed parsing code
 o Updated Pager.man to reflect config changes.

--
1.7.49 patch 26 (mihm)
 o Patch to 1.7.75!
 o Patch to Pager (c/o allanon) to fix Pager death on window close caused by
   patch 15 - the efficiency patch. :)
 o Update *ALL* look files to the new MyStyles format of all Modules that use
   them!
 o Updated the pager.in, wharf and winlist to reflect the MyStyle move as well.
 o Moved README.new_options to NEW
 o Removed the obnoxious REALLY.READ.THIS.IF.YOU.CAN.HELP file, and
   incorporated it into the main README.
 o Modified doc/code/Patch to reflect the needed use of 'makeasversion'.

1.7.49 patch 25 (sasha)
 o fixed memory corruption bug in Pager: ParseOptions() causing wierd 
   behavior, and corrupted root pixmaps.
 o fixed focus change processing in Pager causing it to crash on fast 
   machines.
 o parser stuff is ready to use, and will be implemented in Pager for
   testing, shortly.

1.7.49 patch 24 (allanon)
 o audit: less lenient on what strings are printable ASCII
 o transparency for all windows is now updated when _XROOTPMAP_ID changes, 
   not just visible ones

1.7.49 patch 23 (muligan)
 o fixed bug in functions.c, Maximize did not check for 0%.

1.7.49 patch 22 (sasha)
 o fixed bug in libasimage, that was allocating memory with calloc,
   but deallocating with XFree
 o fixed audit.c to correctly deal with XImages allocated by libasimage
   that should fix memory leaks in all modules when compiled with memory
   auditing
 o better memory cleanup in Pager when compiled with memory audit
 o more parser stuff 

1.7.49 patch 21 (allanon)
 o updated man pages to reflect the fact that modules can be run from the 
   command line, as well as the new -f, --help, and --version options

1.7.49 patch 20 (semyaza)
 o updated some more theme.handler stuff problems w/ parsing.  No version
   increment.

1.7.49 patch 19 (Rwf)
 o ChangeLog reformatted and cleaned up, entries now in newest-first order

1.7.49 patch 18 (allanon, MrRaZz.4world <root@net.HCC.nl>, 
		 Oskuro Iluna <jordi@pusa.eleinf.uv.es>)
 o updated doc/languages/README.es (thanks to Oskuro)
 o added new doc/languages/README.nl (thanks to MrRaZz.4world)
 o Pager: now compiles :) (allanon)

1.7.49 patch 17 (allanon)
 o added new database option, Layer <layer>; layers are an extension of 
   StaysOnBack, StaysOnTop; see the afterstep man page for more details
 o new menu/module command, SetLayer <layer>; sets the layer of the 
   selected window

1.7.49 patch 16 (sasha)
 o Pager now should update transparency when moved
 o default style will now work better if PagerActive/InactiveDesk
   is not specifyed.

1.7.49 patch 15 (sasha)
 o fixed bug preventing transparent Pager to become transparent in some cases.
 o Added memory cleanup code for better memory auditing in Pager.
 o improved command line startup options parsing in Pager.
 o other minor bug fixes and improvements.
 o some preliminary code for configuration parsing left in src/Pager

1.7.49 patch 14 (sasha)
 o fixed random Pager's coreing with SelectionColor and GridColor specifyed.
 o added DeskBorderColor option to PagerDecoration
 o moved HideInactiveLabels and LabelBelowDesk to PagerDecoration
 o Pager will now dynamically resize itself when font size is changed in 
   style.
 o Better support for 3D fonts
 o Support for MyStyle definitions in pager file or .steprc file added
 o minor cleanup
 o updated pager.in and pager.man

1.7.49 patch 13 (sasha)
 o fixed Pager's coreing when PagerSmallFont is specifyed in config.
 o some Pager's optimization, to better handle Page/Desk switching
 o Updated pager.in, look.DEFAULT, pager.man 
 o fixed Pager's coreing when PagerStyle is not specifyed. 

1.7.49 patch 12 (semyaza)
 o fixed typo in makeastheme.pl and installastheme.pl
 o theme.handler version incremented by 1 (0.4.2)
 o made theme.handler scripts print version number when no args given

1.7.49 patch 11 (sasha)
 o This is the first patch in series of Pager rewrite patches.
   Work is still in progress, so there might be minor glitches.
 o Pager now understands MyStyle options. The following styles should be 
   defined :
   "*PagerUWindowStyle"(defaults to "unfocused_window_style") - unfocused 
   window representation's style.
   "*PagerFWindowStyle"(defaults to "focused_window_style") - focused 
   window representation's style.
   "*PagerSWindowStyle"(defaults to "sticky_window_style") - sticky 
   window representation's style.
   "*PagerActiveDesk" - active (selected) desk's style. BackPixmap 129 is
   supported for transparency.
   "*PagerInActiveDesk" - inactive desk's style. BackPixmap 129 is
   supported for transparency.
 o New Pager option added : *PagerStyle <stylename> to define the style 
   of desk's representation window. Transparecncy is supported.
 o The following options has been dropped :
   PagerImage - changed to PagerStyle
   PagerBack,PagerFore,HiBackColor, HiForeColor,PagerFont  - moved to 
    Active/InActive Desk style
   PagerHilightBorders - absolete, can be defined in focused/unfocused 
    window style 
   PagerHilight - moved to PagerDecoration as SelectionColor
   PagerTransparent - moved to style definition
   PagerFastBackground - not very usefful - if somebody needs it - 
     give me a call
 o To disable desk's title - use NoDeskLabel option of PagerDecoration
 o PagerSmallFont overrides focused/unfocused window styles font definitions
   More stuff to come ;)

1.7.49 patch 10 (nekked)
 o new module that will provide Gnome compliancy to AS
 o supported stuff, most GNOME win_state_hints, all of win_workspace,
   all of win_client_list.
 o unsupported or poorly supported, no translation for apps that actually
   use GNOME hints, win_layers completely not supported.
 o usage, there are no config files for this module, either run it from
   commandline or from 'Modules' menu.
 o bugs, too many updates, supported protocols listed but not supported.

1.7.49 patch 9 (allanon)
 o module parameters are passed on by AfterStep again (oops!!)
 o Pager: read .steprc for base options, if using steprc (oops!!)
 o fixed memory leak when in executeModule()
 o removed debugging printf() in KillModule()
 o renamed the install.all rule in Makefiles to install.data
 o added tools/Makefile.in to take care of installing ascommand.pl
 o added an INSTALL_SCRIPT define to autoconf/Makefile.defines.in
 o doc/Makefile.in now uses INSTALL_SCRIPT to install afterstepdoc
 o added install.script rule to autoconf/Makefile.common.in
 o added short blurb to doc/code/Patch describing what to do if the 
   patches are not gzipped
 o modified all Makefile.in's to have a local install and uninstall
 o abort jpeg decompression if not all scan lines have been read; calling 
   jpeg_finish_decompress() in this case is an error

1.7.49 patch 8 (allanon)
 o (module) -f ~/.steprc should work now

1.7.49 patch 7 (allanon)
 o modules now broadcast their name to AfterStep, so KillModuleByName 
   works again; was disabled (as opposed to broken :) in patch 6
 o make install installs ascommand.pl so that external programs (such 
   as asWhiskey, asVodka, etc) can rely on its presence

1.7.49 patch 6 (allanon)
 o new method of module communication, using a UNIX-domain socket in 
   non-configurable; the name of the socket file is stored in the 
   _AS_MODULE_SOCKET X property
 o modified all modules to use the new method of communication
 o no longer use xpm_attributes.bitmap_format or the XpmBitmapFormat 
   flag; these are not in my version of libXpm
 o use the DefaultScreen macro in loadimg.c and stepgfx.c, to help 
   prevent some aterm crashes
 o added handler for XpmCreateImageFromXpmImage() to audit
 o all modules now accept the -h, --help, -v, and --version options; 
   modules with a configuration file also accept "-f configfile"
 o added tools/ascommand.pl, which sends an arbitrary command to 
   AfterStep, just as a module would; in fact, it *is* a module
 o NOTE: modules can now be run from the command line, with pretty much 
   the same syntax as one would use to run them from within AS

1.7.49 patch 5 (nekked)
 o removed the transient WinList option
 o made buttons in vertical mode static
 o added *WinListHideGeometry for winlist in autohide mode
 o changed the behaviour of hidden winlist, it now shows a clock, number of
   clients running, current desk when hidden.  The win05-like hide technique
   didn't work well due to page warping.
 o handlers for SIGSEGV, SIGQUIT, SIGTERM
 o substantialy rewrote winlist in an attempt to reduce the number of redraws
   this is not yet complete.
 o changes to geometry parsing
 o changes to event handling
 o changes to linked list handling
 o winlist is not stable at this time, large chunks of code have been modified
   I'm submitting this patch for people who are willing to test this thing out
   and send me bug reports, if you're not one of them I suggest using an older
   version.
 o bugs - when 'h' pressed current balloon is not destroyed (i suggest
   balloons_off in aslib), sometimes when no apps running winlist will not
   resize properly, too many redraws, probably a lot more that I dont know
   about at this moment.
 
1.7.49 patch 4 (sasha)
 o Major improvement of libasimage:
   - direct XImage data access while processing JPEG and PNG files, when
   possible ( TrueColor and ColorDepth > 8 ), in put_png_scanline and
   put_jpeg_scanline. Improves performance by 10-15%%.
   - XPm files are now read fisrt into XpmImage and then into XImage - 
   surprisingly improves performance by 20%.
   - added image(with mask) loading with scaling capabilities - works much 
   faster then load Image first and then scale it.
   - other minor improvements and fixes.
 o temporary fix of Pager to properly place desk windows with afterstep 
   1.7.51 and higher.

1.7.49 patch 3 (Makoto Kato <m_kato@ga2.so-net.ne.jp>)
 o add fontset support to MyStyle properties
 o gradient text now supports i18n
 o Ident: now supports DBCS
 o Script: now supports DBCS
 o Zharf: now supports DBCS
 o (by allanon): fixed WinList WRT new transparency code in asimagelib

1.7.49 patch 2 (allanon)
 o added new Style options FocusStyle, UnfocusStyle, and StickyStyle to 
   allow setting styles for individual windows; see README.new_options 
   and the afterstep man page for details
 o misc.h no longer includes aftersteplib.h, menus.h, or mystyle.h; this 
   required including those headers in many *.c files, but gives more 
   control over what headers are included, and their order
 o mystyle_find() now returns NULL when passed a NULL pointer (instead 
   of crashing)
 o removed debugging fprintf()'s from mystyle_property.c :)
 o removed xdiff, ydiff, ReliefPixel, ShadowPixel, TextPixel, and 
   BackPixel from struct ASWindow
 o added style_focus, style_unfocus, style_sticky to ASWindow; these 
   keep track of the styles to be used for each individual window
 o removed inclusion of <sys/types.h> from misc.h
 o created new header, style.h, to contain name_list (Style) related stuff
 o rewrote much of style.c to support MyStyle's as Style options
 o ReadFileName() now returns NULL in fname when no characters are read
 o matchWildcards() is now const-correct
 o the system for converting from frame size to client window size and 
   vice versa is now much more flexible, and is concentrated in three 
   new functions, get_client_geometry(), get_parent_geometry(), and 
   get_frame_geometry(); also, titlebar geometry is now calculated in 
   only one place, set_title_geometry()
 o changed several places which used Scr.MSFWindow.colors to use 
   WhitePixel() and BlackPixel() instead
 o removed gradient caching; the cache was worse than useless for 
   VerticalTitles
 o ran indent on borders.c and style.c
 o Style options Color, ForeColor, and BackColor are gone; probably no 
   one will notice, since they weren't in the man pages, and didn't work 
   anyway :)
 o resize handle width is now equal to title width or height, whichever 
   is less

1.7.49 patch 1 (sasha)
 o All aterm imaging/transparency/shading code has been copied into libasimage's:
   ximage_utils.c - updated scaling code now works 3 times faster on TrueColor;
   ximage_utils.c - added XShadeImage - to enable shading/tinting on TrueColor.
   pixmap.c - different pixmap transformation functions - see include/pixmap.h.
 o fill_with_darkened_background moved into pixmap.c, args changed
 o src/Wharf/icons.c, src/afterstep/menus.c and src/afterstep/borders.c
   updated to use new fill_with_darkened_background.
 o src/Wharf/transparency.c removed, due to all functionality being moved
   into libasimage.
 o transparency code from src/afterstep/menus.c removed, due to all 
   functionality being moved into libasimage.   
 o asimagelib/mystyle.c fixed to set tinting color to "white" if it was not 
   specifyed in transparent BG definition, or specifyed color is invalid.


--


1.7.47 patch 2 (nekked)
 o transient winlist fixes
 o winlist moved to use _AS_STYLE's
 o left portion of text is now displayed in the buttons
 o fixes for disappearing text and garbled pixmaps on startup
 o the MyStyle "*WinList" structure should now be specified in the look files
 o updates for the man page
 o I'm intending to drop the support for transient WinList, any objections?

1.7.47 patch 1 (allanon)
 o configure now modifies the start menu title to reflect the AS version
 o fixed the Look, Feel, and Pictures .include's to point to the share 
   dir properly
 o added asimagelib/mystyle_property.c to handle converting MyStyle's 
   to and from X properties; the recommended property to use for this is 
   _AS_STYLE
 o added newlines after MyStyle error messages
 o use mystrdup() instead of strdup() in lib/font.c
 o Wharf: added support for _AS_STYLE property
 o Wharf: now updates look dynamically when _AS_STYLE is changed (ie, 
   when the AfterStep look is updated)
 o yes, IconFont + --enable-iconbackground works; really, it does!


--


1.7.37 pach 10 (mihm)
 o removed nekked from the TEAM file - just kidding :)
 o new README.tw
 o brought to 1.7.47
 o updated TEAM
 o re-ordered the install.script
 o added new theme.handler
 o revised look.Transparent to look.Transparent.rev
 o added the RubberBand item to all looks
 o added aterm entry to startmenu & dir

1.7.37 patch 9 (nekked)
 o fixes for AutoHide in WinList
 o fixes for transparency in WinList
 o fixes for configure window requests in WinList
 o fixes for WinList manpage
 o added myself to the TEAM file as the asetroot maintainer

1.7.37 patch 8 (allanon)
 o fixed icon text drawing... properly this time (hopefully, maybe) :)
 o Wharf: BackPixmap 129 without a previous BackPixmap 128 now works

1.7.37 patch 7 (allanon)
 o windows which attempt to move themselves close to the screen border 
   are now allowed to do so, providing at least one pixel is visible
 o set titlebar button width & height to zero in InitLook(), fixing a 
   problem with titlebar height when a look with fewer (and smaller) 
   buttons is loaded
 o added new MyStyle option, DrawTextBackground, which clears an area 
   behind text to the background color
 o updated look.MacOS8 to use DrawTextBackground
 o icons redraw themselves when exposed again (oops!)
 o icon text uses IconFont again (oops!) :)

1.7.37 patch 6 (allanon)
 o included configure.h in any source files that weren't including it; 
   audit works better now :)
 o update titlebar buttons in SetTitleBar() instead of SetBorder(); 
   updates to the buttons no longer redraw the lowbar
 o no longer attempt to free iconPixmap in Destroy() if the pixmap is 
   set by the app (this is the case for xemacs)
 o create titlebar window after handle windows
 o ignore expose events for the frame and Parent windows, and compress 
   all other exposures as much as possible
 o removed unused MakeGradient() from borders.c
 o create titlebar pixmaps at the proper size for vertical titlebars

1.7.37 patch 5 (nekked)
 o fixed a bug with autohide and and vertical WinList
 o removed Mallocs.*, Colors.* from WinList (it's all in aftersteplib anyway)
 o rewrote WinList to use MyStyles, check the man page for the options, some
   of the old config options won't work anymore!
 o added transparency with tinting to WinList
 o removed unneeded #includes and declarations
 o updated the config file to reflect the changes

1.7.37 patch 4 (allanon)
 o removed old look (!NEWLOOK) code
 o no longer include X11/Xlib.h, X11/Xutil.h, X11/cursorfont.h from 
   afterstep.h and screen.h; these interfered with audit + iconbackground

1.7.37 patch 3 (nekked)
 o added auditing to WinList
 o fixed 2 memory leaks in WinList (unload_font and balloons_init (1))
 o MyName in asetroot reports the module's name correctly
 o the array of pixmaps is freed on exit
 o improvements to the error handler
 o event handler that listens for changes to the _XROOTPMAP_ID property
   and aborts the program if another program tries to access it
 o asetroot will now create ~/g/l/a/asetroot where it will store its
   configuration if the file doesn't exist
 o changed all malloc's to safemalloc's
 o removed all memory leaks
 o to save CPU time images are just tiled if they're the size of the
   display
 o properly grabbing the cursor now

1.7.37 patch 2 (allanon)
 o Wharf: added new option (NoWithdraw) to turn off the ability to 
   withdraw Wharf to a corner; turns off grabbing button 3
 o finally got around to updating README.new_options :)
 o added section to doc/code/Patch on applying patches
 o added more memory debugging stuff, and moved it from lib/safemalloc.c 
   to lib/audit.c
 o added configure option --enable-audit to turn on memory auditing
 o added quotes around arguments to test in aclocal.m4; this helps with 
   some versions of test
 o vertical transparent or gradient titlebars now resize properly
 o fixed memleak in Destroy(); free iconPixmap
 o Wharf: fixed memleak in ConfigureIconWindow() WRT translucency
 o Wharf: delete balloons when deleting buttons
 o fixed memleak in mystyle_parse_member() WRT pixmap paths
 o fixed memleak in dirtree_fill_from_dir()
 o removed @X_LIBS@ from LIBS_X in autoconf/Makefile.defines.in; X_LIBS 
   is included in x_libs

1.7.37 patch 1 (nekked)
 o many bugfixes
 o compilation fixes
 o removed the alarm for rereading conf files, not needed anymore
 o asetroot now saves its configuration on exit
 o added pointer grabs when loading an image
 o increased MAXDESKS to 32
 o images for *asetrootImage# are now searched for in pixmap path, icon path,
   ~, and / paths
 o implemented aspect (scale that keeps the aspect ratio for poster type
   images, the option is aspect
 o added XError handler for cases when killing _XROTPMAP_ID generated X
   errors (X_KillClient)


--


1.7.25 patch 12 (allanon)
 o removed debugging fprintf() (came from patch 10)
 o several minor adjustments to titlebar positioning code
 o fixed ShapeSet() when VerticalTitle is specified
 o fixed HandleConfigureRequest() when VerticalTitle is specified
 o resist_move() now knows about shaded windows
 o fixed PlaceWindow() when VerticalTitle is specified

1.7.25 patch 11 (nekked)
 o different desktops can have different styles
 o changed the format of the config file, *asetrootImage1 <path> <style>
 o added a signal handler that checks (not yet) for config file changes
 o removed things that caused compiler warnings
 o linking with shared libafterstep and libasimage will now work
 o selecting images from the root menu will cause asetroot to update the
   background.  CAUTION: this will not work well if your Pager does image
   handling!  Set Pager to transparent or colour only.  If you decide to
   use asetroot at this stage it is best either to disable Pager, set it to
   transparent or use colour only.
 o updated the man page, help needed!
 o added asetroot to Modules menu.
 o updated the config file to work with new options and to demonstrate the
   syntax.

1.7.25 patch 10 (allanon)
 o Wharf: grab the right mouse button on a swallowed app in a root 
   button even when there is no action defined for the button
 o added new database options, VerticalTitle and HorizontalTitle
 o added afterstep man page entry for VerticalTitle
 o NOTE: TexturedText and VerticalTitle do not work together
 o texture caching for gradient modes 2 & 3 is broken

1.7.25 patch 09 (sasha)
 o added CopyXImageLine function to asimagelib - it can be used to 
   do fast copy of entire horizontal line of XImage from one XImage
   to another of the same type and width.
 o optimized scaling function to speedup enlarging images
 o added PropertyChanged handler to Pager to handle background changes 
   in transparent mode.(even if it is compiled without background support)

1.7.25 patch 08 (nekked)
 o asetroot is a module now
 o man pages updates
 o seems to work great :P

1.7.25 patch 07 (nekked)
 o asetroot can scale, center, tile images
 o it reads ~/G/L/A/asetroot or AFTER_SHAREDIR/asetroot
 o options avaiable:
   *asetrootStyle 1,2 or 3, 1 being center, 2 scale and 3 tile.
   *asetrootImage path to the image you want displayed
 o a small man page...
 o added a sample config file to share/afterstep

1.7.25 patch 06 (allanon)
 o changed names of mystyle functions to mystyle_* to make them less 
   likely to cause namespace conflicts
 o added short howto and example to mystyle.h
 o updated README.new_options to include (hopefully) all new features
 o Wharf: fixed bug when mode 129 is used and no pixmap is defined
 o Wharf: buttons larger than 64x64 work right with mode 129
 o Pager: changed "register" to "register int" to remove a compiler 
   warning

1.7.25 patch 05 (nekked)
 o beginnings of a new module -> asetroot
   this module to eventualy takeover root window backgrounds handling from the
   pager.  The pager will still be able to access the root pixmap via the
   XA_PIXMAP prop.  At this stage asetroot compiles and tiles an image, only
   and also the image filename is hardcoded into the binary.  For use by the
   developers only!

1.7.25 patch 04 (sasha)
 o mystyle.c Added CreateTintGC. 
 o Added pseudotransparency  with tinting option to Pager.
   ( using: *PagerTransparent <desk#> <color>)
 o fixed makeaspatch to properly run tools/makeasclean instead of 
   just makeasclean - it will also not run it on old(AfterStep-current)
   tree as far as we want to patch against unchanged old stuff no matter
   how bad it is 

1.7.25 patch 03 (Makoto Kato <m_kato@ga2.so-net.ne.jp>)
 o WinList: change to using MyFont structure
 o WinList: improved I18N support

1.7.25 patch 02 (uhenden@online.no and lourdas@it.teithe.gr)
 o updated README.no
 o updated README.gr

1.7.25 patch 01 (allanon)
 o Wharf: changed default config to MyStyle's
 o Wharf: no longer crash if an invalid pixmap is requested with old 
   *WharfPixmap command
 o make_styled_icon() with a texture_type of 0 (== solid color) now uses 
   the background color instead of the foreground
 o start/[Look|Feel|Pictures]/.include now use an absolute path for the 
   share dir, to avoid problems (ie, doubled feels in menu) if the share 
   dir is copied to the local dir unmodified
 o improved darken_pixmap() to work better on 32bpp XImages (I hope)


--


1.7.0 patch 25 (allanon)
 o moved mystyle.c from src/afterstep to asimagelib
 o mystyle.c no longer relies on a ScreenInfo structure
 o moved definition of struct config to parse.h, requiring:
 o moved parse.h before misc.h in all C files
 o moved aslib before asimagelib on the link line, since asimagelib now 
   requires aslib
 o moved gradient_t to aftersteplib.h
 o added icon_t to mystyle.h
 o added new function, make_styled_icon(), to return an icon_t (allowing 
   use of pixmap masks)
 o moved make_styles() to configure.c
 o removed Scr.ForeGC, Scr.BackGC, Scr.ReliefGC, Scr.ShadowGC, and added 
   them (without the Scr.) to mystyle.c
 o added new function, get_styled_gcs(), to allow access to the style GCs
 o findIconFile, mystrcasecmp, mystrncasecmp are more const-correct
 o moved GetShadow and GetHilite to lib/getcolor.c
 o moved stripcpy, stripcpy2, and find_config (was match_string2) to 
   lib/parse.c
 o stripcpy2() no longer prints errors
 o Wharf: now uses a style ("*WharfTile") for the button tiles
 o Wharf: added note about style "*WharfTile" to Wharf.man
 o Wharf: mode 129 (with tinting) now works
 o Wharf: an undocumented feature:
   MyStyle "*WharfTile"
     BackPixmap 128 pixmap.xpm
     BAckPixmap 129 blue
   ~MyStyle
   ... will shape the wharf with pixmap.xpm's shape, and make it 
   translucent blue
 o Wharf: added an X error handler which prints and ignores all X errors 
   (this may not be a good thing) :)
 o Wharf: added transparency.c to handle the transparency effect; this 
   may be added to asimagelib at some point
 o Wharf: ran make indent

1.7.0 patch 24 (sasha)
 o Pager will now correctly reset _XROOTPMAP_ID to None when exiting, and 
   that will keep Eterms running on restart of afterstep.

1.7.0 patch 23 (delt <deltax@dsuper.net>)
 o Wharf: fixed redraw bug in pushed buttons
 o fixed shaded window titlebar animation; was adding an extra border 
   width to the final window height

1.7.0 patch 22 (allanon)
 o added new option to menu .include files, "Name"
 o added entry for Name option to afterstep man page
 o root menu is now referred to as PopUp "0", non-configurable/startmenu 
   but "start" is also defined for backward compatibility
 o changed all references from PopUp "start" to PopUp "0"
 o renamed start menu "Start Menu" in the start/.include file, as a 
   demonstration
 o moved warp ungrab from LeaveNotify to FocusOut, because the grab is 
   done on FocusIn; this seems to fix the mysterious repeating key bug 
   for me
 o warp_in_process is now only set when AutoReverse == 2 to prevent any 
   possible bugs in AutoReverse 2 from affecting 0 & 1

1.7.0 patch 21 (allanon)
 o removed XSetCloseDownMode from Pager; see comments in background.c; 
   using XSetCloseDownMode properly in AS would require writing a new 
   app or a major rewrite of old ones
 o mode 129 now uses ParentRelative if the root pixmap cannot be found 
   (via the _XROOTPMAP_ID property), or uses the root pixmap if it can 
   be found
 o changed afterstep man page to reflect new functionality of mode 129
 o mode 129 can now be used with the window decoration styles
 o the move/resize info window now uses the full styled text of the 
   focussed window style
 o makeaspatch no longer always complains of an unchanged version number

1.7.0 patch 20 (nekked)
 o Property changes in x_pager.c made permanent to avoid Eterm crashes
   XSetClodeDownMode.

1.7.0 patch 19 (sasha)
 o added ximage_utils to libasimage. It includes :
   -custom CreateXImageBySample and CreateXImageAndData
     to better create XImages without need to use XSubImage.
     it will allocate XImage's data for you.
   -XImage scaling functions ScaleXImageToSize and ScaleXImage
     to scale up or down XImages.
   as the result of this changes images gets loaded 10%.
 o Optimized Pager's startup code to not resize it's contents only if 
   window size has changed.
 o Pager will not change root background if Pixmap is already
   there.
 o Pager now checks contents of _XROOTPMAP_ID and changes it only
   if it's not the same. That gets rid of unneccesary Eterm/aterm
   refreshes.
 o Added *PagerSetRootOnStartup option to Pager to make it show 
   root background on startup - before notification from AfterStep
   about current desk. This is needed if aterm is started from autoexec
   or even before AfterStep with transparent option.
 o Possibly fixed bug reported by doommaker, when Pager creates
   huge files in non-configurable dir.

1.7.0 patch 18 (allanon)
 o restarting into another window manager works again
 o properly spawn new processes to handle multiple screens
 o added tools/makeasversion to make changing versions easier; modifies 
   README, doc/languages/README.*, and autoconf/configure.in
 o added check for updated version number to makeaspatch
 o replace icons on update look, in case the IconBox changed

1.7.0 patch 17 (fuf)
 o the path to install-sh in now absolute

1.7.0 patch 16 (sasha)
 o Changed esetroot code to set atom after background is changed, not before
   as it was.

1.7.0 patch 15 (allanon)
 o no longer set the backgound of window frames and parents
 o renamed some of the files in the start menu so that they will sort 
   properly with the new menu sorting code
 o replace Exec with Nop properly in the case that the executable is not 
   in the user's path

1.7.0 patch 14 (nekked)
 o WinList autohide option added (*WinListAutoHide 0 or 1)
 o updated the man page approprietely

1.7.0 patch 13 (nekked & lathi)
 o modified afterstep.man to include RubberBand
 o modified WinList.man to include all new options
 o modified makeastheme.pl to truncate trailing spaces from images.
 o added some more debugging to the makeastheme.pl get_image sub.
 o doommaker modified the theme.handler README to describe makeastheme.pl
   a little better.
 
1.7.0 patch 12 (allanon)
 o added balloon_set_position() to allow finer control over balloons
 o fixed balloon positioning, when active rectangles are used
 o Wharf: fixed description of wharf button option lines in Wharf.man;
   mostly WRT the Size keyword
 o Wharf: no longer crash when a menu close button is clicked while over
   a Wharf window
 o fixed David's name in the WinList man page :)
 o files are now closed during start menu melting (oops)
 o Maximize now avoids AvoidCover windows
 o fixed sticky menu move code (was broken by patch 7)
 o SmartPlacement works again (broken by patch 7)
 o icons no longer cover the titles of icons above them when autoplaced
   and NO_ICONBACKGROUND is on
 o correct look is now written (n-c/0_look.#bpp) if DIFFERENTLOOKNFEELS
   is not defined

1.7.0 patch 11 (nekked)
 o improvements and fixes to WinList balloons
 o WinList geometry now fixed again (sasha)
 o cleaned up my misc. garbage

1.7.0 patch 10 (sasha)
 o modifyed tools/makeasclean to remove files from src dir - those 
   files should be just debugging temporary garbage
 o added PagerDecoration option - possible values :
   DeskBorderWidth #  - border width between desks
   NoPageSeparator    - removes lines separating one page from another
   NoSelection        - removes frame surrounding selected page 
   GridColor <color>  - defines color of page separating grid and desk 
                        borders
 o added stuff from Eric Tremblay <deltax@pragma.net> Pager_diff
   unsupported patch
 o changed afterstep/pager.in to reflect changes
 o added allanon's stuff for better swallowing of WM apps in Wharf

1.7.0 patch 9 (nekked)
 o added balloons to WinList
 o removed src/WinList/xinfo.h and went back to using ScreenInfo
 o updated the default winlist file to include balloons
 o added some extra (commented out) options to winlist for examples.

1.7.0 patch 8 (allanon)
 o balloons can now be triggered by an area within a window
 o changed balloon API to remove dependence on global Display*

1.7.0 patch 7 (allanon)
 o added new Style keyword, AvoidCover; other windows will avoid covering 
   an AvoidCover window while moving; if SmartPlacement is specified in 
   the feel file, other windows will avoid covering the AvoidCover window 
   when initially placed
 o added new Style keyword, AllowCover; turns off AvoidCover
 o added AvoidCover to Wharf, Zharf, *Pager, and WinList in the default 
   database
 o added StaysOnTop to WinList in the default database
 o removed extra checks for NoIconTitle and IconTitle in style.c
 o added AvoidCover and AllowCover to afterstep.man
 o changed ".BR" to "\fB\fP" in afterstep.man

1.7.0 patch 6 (allanon)
 o fixed StaysOnBack bug that caused a crash if more than one StaysOnBack 
   window was used

1.7.0 patch 5 (allanon)
 o added .include to the start/ dir
 o added .include's to the start/Desktop/Feel/, Look/, and Pictures/ 
   dirs; these include the ~/G/L/A feels/, looks/, backgrounds/, as well 
   as the /u/l/s/a ones
 o removed sorting functions from lib/homeanddirs.c; they were only used 
   by afterstep, and needed to be changed for dirtrees anyway
 o moved my_scandir from aslib to src/afterstep/myscandir.c
 o added dirtree.c, containing functions to help with start menu melting
 o moved struct config from misc.h to parse.h
 o fixed bug which caused afterstep -f steprc to fail
 o removed old start menu melt code from configure.c (woohoo!)
 o streamlined match_string and match_string2 a little
 o modified makeasclean to clean up after the .include files
 o added "CONFIGURATION OPTIONS - .include" to afterstep.man
 o NOTE: the Looks, Feels, and Pictures directories are no longer special; 
   this means that a user must add a .include to include them in the start 
   menu!! see the default .include's for an example
 o added a more informative error in the case that start/, n-c/startmenu, 
   or fixed/ cannot be found during the start menu melt
 o fixed a memory leak in lib/homeanddirs.c:HomeCreate()

1.7.0 patch 4 (nekked)
 o fixed an unterminated comment in WinList.c
 o allowed server grabs when moving/resizing non-opqaue windows (it just has
   to grab!)
 
1.7.0 patch 3 (nekked)
 o modified WinList to allow for gradients, background pixmaps, 3d text.
 o added a new look option for afterstep, RubberBand, this allows for different
   types of rubberbands when moving or resizing windows, currently there are 3
   0 the old one (default), 1 single rectangle, 2 crossed-out single rectangle.
 o modified one line in asimagelib, MyAllocColors() was using Scr.screen which
   was changed to DefaultScreen(dpy) (the ScreenInfo struct is used by AS only,
   there is no way I would use it in WinList).
 o minor TEAM changes, added a line for module maintainers and myself to AS
   team.

1.7.0 patch 2 (marius <marius@alpha1.net>)
 o Wharf: rewrote man page entries for Rows, Columns, and Geometry, and 
   added an example of Geometry
 o Form: changed sunsite to metalab in config file

1.7.0 patch 1 (allanon)
 o rewrote LowerWindow() so that StaysOnBack now works
 o windows with StaysOnBack now start lowered instead of raised


--


1.5beta6 patch 13 (allanon)
 o Audio: fixed config parsing
 o Audio: now properly ignores events for which no sound is defined
 o Form: changed InputFont to "fixed"; Form assumes a fixed width font
 o changed "horizontal%" to "pixels" in the description for EdgeResistance 
   in afterstep.man

1.5beta6 patch 12 (lathi)
 o stupid me put the wrong switch in the ChangeLog.  It should be
   "--config" rather than "--configure".  I changed it above.
 o Also updated the usage() to reflect new "-c|--config" switch and Rwf's
   "-v|--version" switch.
 o Changed a typo in afterstep.c:main() from " -debug" to "--debug".

1.5beta6 patch 11 (mihm)
 o changed configure.in (autoconf'd) to 1.6.0
 o updated all man pages to read 1.6
 o added new/revised afterstep.man
 o added README.RedHat from "Shadow/Panther"
 o added UPGRADE file
 o got Shadow to update the tools/Uninstall-Old-AfterStep script to
   use variables

1.5beta6 patch 10 (lathi)
 o added new commandline switch for afterstep, "-c" or "--config".  It
   simply prints out the directories that afterstep was configured with: the
   version, bindir, mandir, docdir, sharedir, gnustep dir, gnustep lib dir,
   afterdir, and non-config dir.
 o also updated makeastheme.pl to only warn when it can't find specified
   images instead of die. (fixes nekked's weird problem)

1.5beta6 patch 9 (sasha)
 o corrected Wharf balloon config handling
 o corrected WinListGeometry handling

1.5beta6 patch 8 (mihm)
 o corrected ScreenSaver switch (with vs without passwd)
 o added a few msgs to install.script
 o included Doug Alcorn's theme handler v0.3 in tools/
 o included a better Uninstall-Old-AfterStep script in tools/; which
   will NOT remove the old aspps that were shipped
 o moved the Changelog to the base source dir - much more logical.
 o reworded the README - new language README's will need to be redone.

1.5beta6 patch 7 (fuf)
 o configure now pays attention to CFLAGS and LDFLAGS env. variables and
   correctly substitutes the library paths for libpng and libjpeg
 o added new option to configure script: --enable-script (yes by default)
 o removed ending / from EXTRA_INCLUDES in Script Makefile.in in order for
   Script to compile successfully on OpenBSD
 - many thanks to Jason (jasoni@openbsd.org) who allowed me to test AS
   installation on his OpenBSD machine

1.5beta6 patch 6 (tigr)
 o changed test -e into test -f for Solaris in Makefile.common.in

1.5beta6 patch 5 (allanon)
 o moved -lpng before -lz -lm in the linker flags; a library which depends 
   on other libs must come before the other libs or ld isn't happy :)
 o VT_FIND_LIBJPEG looks for <jpeglib.h> instead of <X11/jpeglib.h>; this 
   prevents "-I/usr/include" from being added to CFLAGS unnecessarily
 o VT_FIND_LIBPNG looks for <png.h> instead of <X11/png.h>; this prevents 
   "-I/usr/local/include" from being added to CFLAGS unecessarily
 o check for XpmWriteFileFromPixmap in libXpm; define HAVE_XPM_WRITE in 
   configure.h if found
 o Pager: only use XpmWriteFileFromPixmap if HAVE_XPM_WRITE is defined

1.5beta6 patch 4 (fuf)
 o fixed the configure script so it finds jpeg and png libraries correctly
   on freebsd
 o replaced the relative path for the install-sh program with the absolute
   one - this caused problems with installing modules and afterstep
 o fixed routines for reading the configuration files in almost all
   modules (Form and Script still must be done) - this fixed many memory
   leaks 
 o various leaks fixed
 o added testing for the man page for a module - the installation would
   fail if the man page wasn't present
 o removed the -s flag in doc/Makefile.in for INSTALL_PROG - this resulted
   in failed installation 

1.5beta6 patch3 (asullivan)
 o yet another small change to the FAQ
 
1.5beta6 patch 2 (tigr)
 o rearranged libraries and the search order for Xpm include files
   for Sun Solaris in autoconf
 o made the install.man install the man pages under prog.1x rather
   than prog.man (Solaris does not understand prog.man)

1.5beta6 patch 1 (asullivan)
 o replaced old FAQ with current version


--


1.5beta5 patch 22 (mihm)
 o doc/html is installed now for sure, as well as afterstepdoc script!
 o added asullivan's FAQ 1998-11-9
 o adjusted configure.in for "make ; make install" simplification
 o fixed some bad start/* program calls introduced in patch 20, which
   use some fancy exec sh -c "exec asclock || exec xclock" :)
 o fixed Animate error by changing grey1 to white in animate file
 o added "Window Properties" to Windows entry of menu, and mentioned it
   in database file.
 o sync'd the (modified) look.DEFAULT with the n-c/*_looks.
 o added a TODO.B4-1.5.0 file in <src-root> to be completed and rm'd
   uon release of 1.5.0.

1.5beta5 patch 21 (sasha)
 o added ViewportX & ViewportY styles - allowing to do flexible StartOnPage
   stuff. It will move screen to the specifyed pos on desk, before placing 
   the window.
 o minor fixing to style.c parsing code, to avoid memory leak in some error
   conditions.
 o some parsing code has been moved to usefull functions (ReadIntValue, 
   ReadColorValue and ReadFileName ).These functions placed in parce.c in 
   libafterstep and available for other modules for parsing purposes.

1.5beta5 patch 20 (mihm)
 o removed/renamed various uneeded file from TODO
 o various fixes and trimmings in the afterstep/ tree
 o added base.15bpp in approþriate places
 o included newest version of FAQ (17 October 1998) in doc/
 o fixed make install not building/installing FAQ
 o updated Teams file [who is this davemann character? :) ]
 o updated the main README and corrected the various doc/languages/README.*s
 o 'make install' now does it all list most normal apps (: 
   (make install == make install.bin ; make install.all ; make install.man)

1.5beta5 patch 19 (allanon)
 o removed line with a solitary "with_gnustep_dir" from configure.in
 o Wharf: now sets swallowed windows' border widths to 0
 o added check for modified configure.in and unmodified configure to 
   makeaspatch
 o added check for older configure than configure.in to makeaspatch

1.5beta5 patch 18 (sasha) 
 o Pager placement fixed ( finally :) )

1.5beta5 patch 17 (allanon)
 o removed TextureTypes from look.Transparent; it was unnecessary, and 
   confused anyone trying to edit the look
 o make install for aslib and asimagelib now only runs ldconfig on Linux 
   systems, and checks for the presence of the library dir in ld.so.conf
 o make install for aslib and asimagelib now only builds and installs 
   the dynamic library if necessary
 o changed the default from --disable-staticlibs to --enable-staticlibs; 
   too many people have trouble with compiling/installing/using dynamic 
   libs
 o added --enable-gdb option; compiles AS with gdb debugging symbols; 
   default disabled
 o added --enable-gprof option; compiles AS with gprof profiling symbols; 
   default disabled
 o added note to doc/code/Optimizing mentioning --enable-gprof
 o moved declaration of timer_first from timer.h to timer.c
 o made internal balloon globals static
 o rewrote balloon_delete() and timer_delete(); the previous method would 
   crash if the global list of objects was empty
 o Wharf: DropExec commands are now allowed to omit either or both of %s 
   and %d
 o removed getopt; it is non-portable

1.5beta5 patch 16 (sasha) 
 o TODO dir cleaned up 
 o All scripts are moved to tools dir
   I'was not sure about some scripts in TODO dir, so they remained there 
 o afterstep dir cleaned up from config files, that gets generated by configure   
 o modified makeasclean to reflect listed changes, and also perform sources cleanup from
   empty files and debug leftovers like "errors"
 o configure options --with-gnustep-lib and --with-afterdir where changed so now 
   you need to supply patch within gnustep dir and within gnusteplib dir respectevely
   ( like --with-gnustep-lib=Library --with-afterdir=AfterStep )
 o added copy of afterstep.html - without that as faq gets incompletely and 
   does not work :/

1.5beta5 patch 15 (sasha) 
 o better libPNG detection

1.5beta5 patch 14 (sasha) 
 o Added -lm to make flags, when building with PNG support.
 o Fixed Pager code to let AfterStep wait for Pager to start completely.
 o Added Pager config option *PagerFastStartup, to force Pager to report
   it's readiness, right after the first background loaded. ( see man Pager
   for more details ).

1.5beta5 patch 13 (sasha) 
 o Added missing ldconfig after dynamic lib installation 
 o libafterstep and libWidgets now linked dynamicaly by default
 o all libs copied to /usr/local/lib only when user runs make install
   and not in compile time
 o minor changes has been made to some modules, to make it compatible with
   libafterstep ( MyName, dpy, screen, DeadPipe ), minor bugs in agrv handling 
   fixed on the way. 
 o added configure option to enable static library linking vs. dynamic.          

1.5beta5 patch 12 (allanon)
 o newlook only: improved menu mode 129; it now grabs the background 
   instead of not drawing it at all; when moved, it now unmaps, grabs 
   the background, and remaps
 o newlook only: menu item background must now be set to 129 for menu 
   items to be transparent
 o updated look.Transparent
 
1.5beta5 patch 11 (allanon)
 o fixed bug in patch 9; !RandomPlacement works properly again
 o fixed bug in patch 9; menus from titlebuttons are placed properly 
   again (well, at least as properly as they were before)

1.5beta5 patch 10 (sasha)
 o added PNG support for Pager, afterstep, Wharf
 o added received patch for Pager (labels below desk, hiding inactive labels )
 o fixed problem with Pager reported by Lathi
 o some improvements to asimagelib, makes it safer
 o asimagelib now is a dynamic lib
 o code has been put in place to easyly move aftersteplib to be dynamic, if
   that is desirable
 o imaging libs ( JPEG, PNG, ZLIB, asimagelib ) now gets linked only when needed 

1.5beta5 patch 9 (allanon)
 o moved checks for xpm.h in /*/include/X11/ before /*/include/; since 
   AS uses X11/xpm.h unconditionally, we only want X11/ dirs anyway
 o added more checking for invalid IconBoxes; IconBoxes are now limited 
   to the screen size, and the bottom/right must be below and to the 
   right of the top/left
 o icons now have a default position, in case no IconBox is defined or 
   none are suitable: (0, 0)
 o changed 0 to NULL when referencing a pointer; this isn't a bug on any 
   modern systems, but people using 20-year-old hardware will thank me! :)
 o argv[0] is copied into malloc'd ram, just in case getopt does 
   something strange to argv
 o fixed bug on restart; was calling execvp() with a null argument list

1.5beta5 patch 8 (allanon)
 o removed BACKWARDS - it got in the way once too many times :)
 o ASWindow.title_height is now the title window height (instead of the 
   title window height + the title window border width)
 o removed NS_HANDLE_HEIGHT
 o removed some redundant code from AddWindow()
 o improved title text vertical centering
 o improved title button vertical centering
 o NoHandles + BorderWidth + TitleBar works much better now
 o simplified RandomPlacement code slightly

1.5beta5 patch 7 (Rwf)
 o removed all code relating to saving argv - not necessary
 o rewrote restart segment of Done() for better execution
 o getopt-ized afterstep's core, lots cleaner now :)
 o more cleanups in autoconf/
 o fixed a few pesky compile warnings

1.5beta5 patch 6 (sasha)
 o major Pager rewrite 
    - fixed lots of unsafe stuff
    - Pager now better handles Page/Desk switching with less load on X
    - better handling of sticky icons
    - many ninor improvements
 o fixed patch03 related bug in afterstep, causing icons to disappear
   when compiled with --enable-iconbackground=yes ( reported by Tigr ) 
 o minor fix to Animate - to better handle situations, when requested
   color cannot be allocated.   

1.5beta5 patch 5 (allanon)
 o added "make install" to install instructions in README
 o added makeaspatch and makeasclean to doc/code/, and described how to 
   create a patch with them in doc/code/Patch
 o changed version from 1.5beta4 to 1.5beta5
 o added mystrdup and mystrndup to aslib; strdup() is not portable
 o added InitBase() to take care of initializing vars from the base.#bpp 
   config file (IconPath, ModulePath, PixmapPath)
 o added InitDatabase() to take care of initializing vars from the 
   database config file (Scr.TheList, Scr.DefaultIcon)
 o added a kill_client argument to Destroy; if False, Destroy() only 
   calls RestoreWithdrawnLocation() instead of killing the client window
 o improved memory allocation checker; countrealloc() works now :)
 o removed safemalloc prototype from Clean, Ident, Pager, Save, Scroll, 
   Wharf, WinList, Zharf; included aftersteplib.h instead
 o Wharf: debugging output is now off by default
 o free display_string and rdisplay_string in main()
 o Reborder is no longer recursive, and uses Destroy(,False) instead of 
   Reborder_unmap
 o removed Reborder_unmap
 o moved Reborder before ClosePipes (in Done()) to prevent spurious 
   allocations showing up when exiting AS
 o added code to free a bunch of stuff just before exit, to prevent 
   spurious allocations showing up; this code is only compiled if 
   DEBUG_ALLOCS is defined
 o added Stdfont, Windowfont, Iconfont to store the font names while 
   loading look; they are much easier to deallocate properly than 
   Scr.IconFont.name, etc
 o fixed bug which caused several vars to be deallocated in InitLook only 
   if they were == NULL; this one was my fault :)
 o changed instances of stuff like "Stdback = white" to "Stdback = 
   mystrdup(white)", so that vars like Stdback can be deallocated safely
 o attempt to free global_base_file in MakeMenus() only if it is non-NULL
 o changed several calls to KillModule to have unique "where"'s (second 
   parameter)
 o delete menus properly in QuickRestart()
 o AutoPlace() now pays attention to the SHADED flag
 o no longer force client icon windows to 64x64 with !NO_ICONBACKGROUND
 o SmartPlacement() now checks StubbornPlacement properly
 o removed code that set the Stdfore and Stdback to the "*" style colors; 
   this did not work properly with the new QuickRestart() (required that 
   we always reload look when loading database)
 o added RemoveFromList to take care of deleting a Style

1.5beta5 patch 4 (sasha)
 o minor changes to asimagelib, Pager
 o even better support for JPEG in afterstep - now buttons and icons can be
   in JPEG format. 
 o minor fix to afterstep to prevent buffer overrun, while parsing buttons config string   

1.5beta5 patch 3 (sasha)
 o image loading code separated in to asimagelib. Changed:
   configure.in
   configure
   Makefile.in
   Makefile.defines.in
 o afterstep was modified to use image loading code from asimagelib 
 o afterstep no support window icons in JPEG format
 o Wharf modified to use image loading code from asimagelib 
 o Wharf now supports JPEG format
 o minor fixes to Pager (fuf typo, waitpid() on Solaris + more )

1.5beta5 patch 2 (sasha+fuf)
 o faster JPEG image loading 
 o partly fixed reported bug about deiconifyed windows staying on wrong desk in
   Pager
 o numerous Pager fixes from fuf

1.5beta5 patch 01 (allanon)
 o moved warp_ungrab() to HandleKeyPress()
 o only forward keypresses (in HandleKeyPress()) if we weren't warping
 o changed Animate draw function to GXxor from GXequiv; the animation 
   color is now the color specified by the user (instead of its 
   complement)


--


1.5beta4:

patch 11 (fuf)
 o i18n changes thanks to Makoto Kato
 o balloon delay problem fix for pager thanks to allanon
 o changed the order of libraries passed to the compiler so SCO and SGI
   don't complain
 o fixed look.AfterStep
 o fixed three memory leaks that occured when a new window has been added
   - this took forever to locate and fix.

patch 10 (allanon)
 o improved speed of mystr[n]casemp(); thanks to David Taylor!
 o always try to set the icon font, even if no font is specified in the 
   look file
 o icon title boxes (with NO_ICONBACKGROUND and !StickyIcons) now unmap 
   on desk change
 o init_old_look_variables() now frees resources

patch 9 (sasha)
 o fix for the desk title bug caused by previos patch :)

patch 8 (sasha)
 o fix for Pager placement code bug, causing incorrect pixmap at the 
   Pager's window, when Pager is placed vertically.
 o Pager now maps it's window right away, so you can watch it loading images,
   and not just be sitting in darkness.  
 o minor JPEG loading code improvements
 o Pager now will not display error message if you specify '*PagerFont  none'. 

patch 7 (sasha+Lathi) 
 o minor bugfix in Pager code for external image viewer args handling
 o got rid of separate Pager_noxpm - everything merged in to Pager, 
   configure option --enable-pagerbackground=no will disable Pager's 
   background support
 o Pager geometry -0-0 bug fixed

patch 6 (allanon)
 o sort_by_numbers now takes precedence over all other sorts, including 
   sort_by_type and sort_by_date
 o changing from a look with no titlebuttons to a look with titlebuttons 
   no longer causes blank space at the bottom of the window
 o SloppyPlacement no longer ignores whether or not windows are shaded

patch 5 (sasha)

 o numerous Pager bugfixes 
 o JPEG support for backgrounds 
 o external image loader arguments can be specified in pager's config vs.
   compile time 
 o root background scaling to Pager's desk window
 o I18N support in Pager
 o more intuitive settings ( PagerImage and PagerDesktopImage ) implemented

patch 4 (mihm)
 o fixed all look files, hopefully they are all current now -
   look.Transparent now works (needs previous patches)
 o reduced all 8bpp icons to a more reasonable 10 colors
 o created NEW default start-up look and asscociated look.DEFAULT.NEW file
 o minor modification to startmenu

patch 3 (allanon)
 o update the ResizeGeometry properly on QuickRestart
 o update the IconBox properly on QuickRestart
 o removed "# do nothing" lines from autoconf/Makefile.common.lib.in; 
   these lines reportedly caused problems with non-gnumake
 o added some commentary about Wharf button sizing to README.new_options
 o fixed trailing comment detection; we now assume that '#' followed by 
   three or more hex digits is a color; eg, #fff, #ffffff, #ffffffffffff 
   are all valid colors
 o window border width > 1 no longer causes problems for the titlebutton 
   placing code; this doesn't matter a whole lot, as the border width is 
   always 1 when a titlebar exists
 o update the window frame size when the titlebar height changes (via a 
   QuickRestart(look))
 o removed built-in bevel on gradients
 o fixed DrawMenuBorders 1 to draw the borders better
 o fixed MacOS8 look some; we now use the right hilight color and 
   DrawMenuBorders 2
 o set clipping mask when drawing menu hilites with DrawMenuBorders 2 
   and 3; only the hilited menu item's border is drawn with the hilited 
   item's hilite/shadow colors
 o added look.Nextish, based on the look.Nextish that was included with 
   AS 1.4.5.55N6
 o Pager now sets the _XROOTPMAP_ID atom that Eterm uses to determine 
   the desktop background

patch 2 (allanon)
 o added DrawMenuBorders 3; draws a border around the title, all items, 
   and the hilited item
 o changing a shaded window's size now resizes the client window properly

patch 1 (Makoto Kato <m_kato@ga2.so-net.ne.jp>)
 o added fontset support to balloons, Pager, Wharf, and Zharf
 o new configure option "--enable-xlocale" added; this flag defines 
   X_LOCALE, which is needed for DBCS font support
 o updated README.jp


--


1.5beta3:

patch 19 (allanon)
 o fixed some compile-time warnings
 o i18n no longer causes a crash when changing look
 o !XPM and JPEG works
 o removed some debugging output
 o replaced look.Metallic with look.Metallic.NEWFORMAT
 o moved titlebar pixmaps from afterstep/backgrounds to 
   afterstep/desktop/icons/common
 o changed version to beta4, in preparation for release
 o remade default startmenu
 o menu mode 129 now works again
 o menu shortcuts now execute their associated item, not just hilite it
 o NOT IN THIS PATCH: ran make indent; the output is a couple megs, so 
   this was reserved for just before release

patch 18 (allanon)
 o un-reversed configure option (different-looknfeels)
 o fixed problem with quotes in checking for -g and -Wall
 o menu items are now deselected properly when using keyboard 
   shortcuts
 o fixed crash on exit

patch 17 (fuf)
 o fixed --enable-menuwarp
 o added compile time option --enable-fixeditems to enable merging user's
   local menu directory with the one in @after_share@/fixed (it still
   needs more work though).

patch 16 (mihm)
 o updated all look & feels to newformat and new options
 o added new look with associated pixs

patch 15 (allanon)
 o ./configure is now non-interactive; run ./configure --help for help

patch 14 (allanon)
 o rebind key/mousebindings on QuickRestart("feel")
 o remove old titlebar buttons before adding new ones on 
   QuickRestart("look")
 o added FocusChangeMask to window frames; this allows shaded windows to 
   properly get focus; removed FocusChangeMask from titlebuttons

patch 13 (allanon)
 o fixed keyboard control of menus again; hopefully it will stay fixed 
   this time :)
 o fixed BorderWidth keyword; the behavior is:
    NoHandles, !BorderWidth  : no lowbar, border is 0
   !NoHandles,  BorderWidth 5: ignore BorderWidth, border is 1
    NoHandles,  BorderWidth 5: no lowbar, border is 5
   !NoHandles, !BorderWidth  : border is 1

patch 12 (fuf)
 o changed linking of the AS library that caused problems to some
   compilers
 o fixed bug when no titlebar buttons were defined and thus titlebars were
   2 pixel high only
 o when the font size or button height changes the titlebars are updated
   accordingly
 o moved the code for (un)stickying window to a standalone function
 o added "#include <limits.h>" so AS can compile on *BSD cleanly
 o changed errors in configure.c go to stderr instead of stdout
 o .orig files in @share_dir@ are removed now when they were created by
   patching and copied to the share dir.

patch 11 (mihm)
 o added other terminal items to menu since xiterm is not pkg'd with
   base src-tree

patch 10 (allanon)
 o added dummy install, install.man, and uninstall make targets to 
   Makefile.common.lib; this may smooth installation using versions of 
   make which stop after an error
 o fixed a problem with embedded double-quotes (") in configure; this 
   caused trouble on OSF/1
 o added a new function, AutoPlaceStickyIcons(), to take care of re-
   placing sticky icons; the icons were "dancing" because each icon was 
   replaced individually, and they were stepping on each others' toes :)
 o added "#include <string.h>" in several places
 o added "#include <time.h>" in several places
 o changed close() to fclose() in Script.c
 o removed memcpy() prototype from Tools.c
 o changed strcasecmp() to mystrcasecmp() in several places
 o cast a difference-of-pointers (ie, ptr2 - ptr1) to int in several 
   places; this removed some warnings when compiling on AIX
 o updated doc/code/ChangeLog to include descriptions of some of my 
   older patches

patch 9 (Leddy)
 o When alt-tabbing next key typed would echo 3 times to screen. Fixed 
   function call to properly route alt-tab, and XSendEvent will only echo when
   it should.

patch 8 (allanon)
 o shaded windows now get keyboard focus; this means AutoReverse 2 now 
   works properly with shaded windows; NOTE: keyboard events cannot be 
   sent to the (unmapped) client window, so they are sent to the window 
   frame (which ignores them)

patch 7 (fuf)
 o OpaqueResize is not a flag anymore, one can specify the amount of
   percents of screen the window "consumes", so when that number is
   exceeded (before resizing) the window is drawn outlined when being resized

patch 6:  <by Rob Foehl, rwf@loonybin.net>
 o Removed Makefile.common and Makefile.common.lib from autoconf/
 o Fixed problem with missing include tags in Makefile.common.lib , caused
   files in lib/ to spit out missing header errors
 o Added check for duplicate include paths to configure
 o Removed Makefile from doc/ , yet another stale makefile..

patch 5 (allanon)
 o added "make indent"; automatically indents all source in the lib/ and 
   src/ trees, and indents headers in include/
 o --with-locale now sets the locale
 o added new feel keyword MWMFunctionHints; if set, use defined Motif 
   window manager function hints (ie, allow/disallow move/resize/etc)
 o added new feel keyword MWMDecorHints; if set, use defined Motif window
   manager decoration hints (ie, show/hide titlebar/titlebuttons/etc)
 o added new feel keyword MWMHintOverride; if set, allow a function to be 
   applied to a window even if the Motif function hints would normally 
   disallow that function
 o Wharf: fixed OffiX drag-and-drop support; NOTE: OffiX d&d is 
   implemented via ClientMessage events, so a drop on a swallowed window 
   cannot be detected by Wharf

patch 4 (fuf):
 o fixed reported problem with comments on the same line as other commands

patch 3 (allanon)
 o got rid of compiler warnings on arguments to timer_delay_till_next_alarm
 o titlebar buttons now depress properly when clicking on a transparent 
   part of the button

patch 2 (allanon)
 o changed -O6 to -O2; -O6 was causing run-time problems for a user with 
   gcc 2.7.2.3
 o use the CFLAGS determined by configure, without -g
 o only add -Wall if the compiler is gcc
 o added --with-locale; currently does nothing
 o added --enable-shaping; enables or disables shaped window extension
 o added --enable-jpeg; enables or disables libjpeg support
 o --with-xpm now works
 o changed the check for libXext; hopefully configure will find libXext 
   on more machines now
 o fixed lots of bugs in NO_TEXTURE; it should now work
 o fixed some bugs with !XPM; it works, but it's not pretty - we need 
   non-xpm titlebar buttons for it to be usable
 o fixed a compile-time error with !SHAPE and NO_ICON_BACKGROUND; this 
   combination now works
 o menus can now have titles anywhere in the menu, and can have mutiple 
   titles

patch 1 (fuf)
 o added new look file options: 'TitleButtonSpacing' and
   'TitleButtonStyle' and added the brief description of their
   functionality to README.new_options
 o titlebar buttons now can have different sizes (horizontal and/or vertical)


--


1.5beta2:

patch 1 (mihm+allanon)
 o configure: added zharf.in, for @usedesktops@
 o configure: changed "number of additional desktops" to "number of 
   desktops", and the default from 3 to 4
 o configure: fixed make instructions
 o configure: added @usedesktops_1@, which is @usedesktops@ - 1
 o fixed share .in files to correctly take the above new configure args
 o fixed autoconf having not been run on new autoconf/configure.in :)


--


1.5beta2:

patch 2 (allanon)
 o added new make target, uninstall.all; removes binaries, man pages, and 
   the global afterstep share directory
 o fixed a bunch of compiler warnings

patch 1 (mihm+allanon)
 o configure: added zharf.in, for @usedesktops@
 o configure: changed "number of additional desktops" to "number of 
   desktops", and the default from 3 to 4
 o configure: fixed make instructions
 o configure: added @usedesktops_1@, which is @usedesktops@ - 1
 o fixed share .in files to correctly take the above new configure args
 o fixed autoconf having not been run on new autoconf/configure.in :)


--


1.5beta1:

patch 5 (mihm)
 o included audio files (they were previously 0 length files)
   [! these are not in patch, as patch doesn't handle the binaries !]
 o added README.new_options, brief explanation of some new features/options
 o replaced autoconf/configure.in with a more cross platform friendly
   version - supplied by Guylhem.
 o combined KERNEL and SHARE - as suggested by Michal & Ethan.

patch 4 (kernel) (allanon):
 o fixed install.script
 o fixed faulty includes from Pager_noxpm
 o put preprocessor guards around "TO BE DONE" in Script/Instructions.c
 o print an error message when a look, feel, or background file cannot be 
   found, instead of crashing

patch 3 (kernel) (allanon):
 o fixed a prototype/definition incompatibility with ParseColor
 o fixed I18N support some more :)
 o fixed bug in font initialization
 o no longer always parse feel
 o no longer parse look when melting startmenu; if you want to turn on/off 
   MenuMiniPixmaps: update look then update startmenu - or - update all

Guylhem AZNAR patch 1 & 2
 o fixed AVAILABILITY CHECK
 o fixed wharf animate
 o fixed pager desks number
 o fixed pager_noxpm
 o fixed lib Makefile
 o fixed compile time warnings in lib/ and src/afterstep


--


1.5pre9:

patch 14 (fuf)
 o fixes for various memory leaks that occured when look or feel was
   changed

patch 13 (allanon)
 o Wharf: fixed bug with shaped wharf & non-shaped icons

patch 12 (allanon)
 o StubbornIcons now works
 o broadcast a window's desk change when it deiconifies to a different
   desk than it was originally on

patch 11 (allanon)
 o give NOICON_TITLE flag its own number; previously it shared numbers
   with the SHADED flag

patch 10 (allanon)
 o draw entire string in draw_styled_text(), instead of each character
   individually; this fixes a bug introduced in 1.5p8 patch 0

patch 9 (allanon)
 o only recalculate EdgeScroll when parsing feel

patch 8 (allanon)
 o when using AutoReverse 2 (ie, patch 6), watch keypresses instead of
   grabbing them; this prevents problems with apps like xterm which don't
   like XSendEvent()

patch 7 (allanon)
 o number of titlebar buttons is now based entirely on the look file 
   (and any NoButton keywords from database, of course)
 o added init_titlebar_windows() and create_titlebar_windows(); these 
   two functions allow removing and re-creating the titlebar without 
   destroying and re-creating the entire frame
 o added init_titlebutton_windows() and create_titlebutton_windows(); 
   these two functions allow removing and re-creating the titlebar 
   buttons without destroying and re-creating the entire frame
 o added button_sanity_check() to take care of adding/removing titlebar 
   buttons as necessary after a look is loaded
 o Reborder()/Destroy()/CaptureAllWindows() are no longer used by 
   QuickRestart()
 o Reborder() no longer deletes menus (this was incorrect behavior)
 o added NO_BUTTON_STYLE, to distinguish buttons that have no look (and 
   thus should not be shown)
 o Destroy() now prevents the UnmapNotify sent by XReparentWindow(); this 
   allows the Reborder()/Destroy()/CaptureAllWindows() trick to work 
   without junking all X events; we no longer use this trick, but it 
   might be useful later

patch 5 & 6 (fuf)
 o fixed many things

patch 4 (allanon)
 o on a button press in the titlebar, check if the press would have been 
   on a titlebar button, had the button not been shaped; if so, act as if 
   the titlebar button had been clicked    
 o when NO_WARPPOINTERTOMENU is off, always warp the pointer, not just
   when the menu was clipped to the bottom of the screen
 o swapped FocusedWindowStyle and UnfocusedWindowStyle
 o swapped MenuItemStyle and MenuItemHiliteStyle
 o put titlebar at bottom of window, lowbar at top of window

patch 3 (allanon)
 o removed server grab when moving windows; client windows now update
   during a move

patch 2 (allanon)
 o removed stray printf's from previous patch 
 o WindowList menu is no longer transient (ie, it can be pinned); it is  
   updated when: a window is created, a window is destroyed, a window is
   raised, a window is moved to another desk, desk is changed


--


1.5pre8:

patch 11c (MJ Farmer)
 o fix free_window_list() in astile and ascascade

 (Guylhem):
 o fixed Autoreverse
 o fixed menuminipixmaps by putting them in looks
 o fixed startmenu analysis : before, startmenu was parsed 1st, now it's
 parsed after look & before feels, so it's possible to have startmenu
 options in look files -> added parselook to quickrestart (startmenu)
 o replaced each Imakefile by GNU autoconf stuff

patch 11b (sasha)
 This patch fixes a bug in Pager module, that appears when trying to
 use non XPM files as root background. It also fixes minor memory leak
 in the code that shows XPM file as root background.
 It is also adding new functionality to Pager, enabling it to use separate
 images for Pager desktop's window background and for root background
 ( for instance - large image as the root and scaled down version of the
 same image in Pager.)
 Use *PagerWallpaper instead of *PagerXPM setting in pager file to specify
 separate image for the root image.
 You must use this setting in order to use non XPM files in root, as far as
 Pager will try to put this image as the desktop's window background
  otherwise, and will give you an error as far as it is not yet capable of
  using non XPM images as it's own background.
 See also the man page for Pager.

patch 11a (guylhem)
 o lots of stuff, only a brief listing follows
 o changes to READMEs
 o changes to looks, feels
 o update to afterdoc
 o added asapm from Alber Dorofeev
 o by Ethan: a couple of fixes to previous patches (a stray line in
   afterstep/icons.c, a fix for JPEGLIBARY)

Makoto Kato <m_kato@ga2.so-net.ne.jp>

 o modified AfterStep-1.5 : current version supports
   internationalization by official, but it don't support any modules
   So these patchs support some modules, based on AfterStep 1.0 i18n patch
   by Tomonori Manome <manome@itlb.te.noda.sut.ac.jp>

		-Support "Pager" module

		-Update "WinList" module
		 Mojibake-fix

		-Limitted support "WinList" module

		-Support "Form" module.

patch 15 (allanon)
 o added BalloonDelay, which sets the delay in milliseconds till the 
   balloon pops up; available everywhere balloons are (wharf, zharf, pager)

patch 14 (allanon)
 o fix bug with NEWLOOK: DrawOutline() was using GCs that had not been 
   created

patch 12 & 13 (allanon)
 o fixed JPEGLIB compile option - it was in compilation.h, is now in 
   compilation.h.in
 o moved balloon.c, GetColor(), load_font(), and unload_font() to aslib
 o modified afterstep, wharf, zharf, and pager to use new aslib functions
 o aspostit now uses screen number instead of Screen*, to allow it to 
   compile with new aslib functions

patch 11 (allanon)
 o Wharf: rewrote Swallow parser, eliminated a possible segfault (which 
          could have ocurred if the Swallow line was malformed)
 o Wharf: added MaxSwallowModule

patch 10 (allanon)
 o Wharf: added bounds check to BalloonBorderWidth
 o Wharf: BalloonYOffset works now

patch 9 (allanon)
 (see 1.5p7 patch 10)

patch 8 (allanon)
 (see 1.5p7 patch 9)

patch 7 (allanon)
 o added support for jpegs (via libjpeg) to buttons and textures in main AS

patch 6 (allanon)
 o initialize MArrowPixmap on restart; changing from a look which defines 
   this to one which doesn't works now

patch 5 (allanon)
 o fixed crash when raising an icon window (with NO_ICON_BACKGROUDN)
 o IconTitle feel option works now (with NO_ICON_BACKGROUND)

patch 4 (allanon)
 o Wharf: added balloons (tooltips) to each button; the balloons contain 
          the label of the button

patch 3 (allanon)
 o when NO_WARPPOINTERTOMENU is off, always warp the pointer, not just 
   when the menu was clipped to the bottom of the screen

patch 2 (allanon)
 o added initialization of completeIcon.mask to new_button(); this fixes 
   a crash under Accel-X due to XFreePixmap() of a random pixmap id

patch 1 (allanon)
 o finished implementing AnimateSteps, AnimateStepsMain, AnimateDelay; 
   wasn't much left to do - guylhem already did most of it
 o changed main wharf button ordering back to 1.5.55N6 style

patch 0 (allanon) (BACKWARDS!)
 o NOTE: this patch is for amusement purposes only; I don't support any 
   features from this patch!!
 o swapped FocusedWindowStyle and UnfocusedWindowStyle
 o swapped MenuItemStyle and MenuItemHiliteStyle
 o put titlebar at bottom of window, lowbar at top of window
 o reversed titlebar button placement
 o reversed order of menu items (title is at bottom, etc)
 o reversed layout of meu items (text on right, menu arrow=20
   on left, etc)
 o reversed drawn menu arrow (not pixmap)
 o reversed all text!

Brett Taylor
 * BSD compilation patches

Chris Zimman
 * 2 small cleans in configure.h

Guylhem Aznar
 * Added MoMiniPixmaps flag but changed to M. Vitecek
   MenuMiniPixmaps (90% ==)
 * Made Animate settings wharf config. file options (not working yet)

Peter Enderborg
 * small fix to add mini pixmaps to menus


--


1.5pre7:

patch 10 (allanon)
 o allow pinned menus to remain in place when QuickRestart("feel")'ing 
   (patch 9 only worked for looks)

patch 9 (allanon)
 o allow pinned menus to remain in place when QuickRestart()'ing

patch 8 (allanon)
 o added check for parse_look before trying to use old-style keywords; 
   this only affected non-NEWLOOK (though was wrong for NEWLOOK as well)

patch 6 (allanon)
 o set IconFont to Scr.IconFont in icons.c; NO_ICON_BACKGROUND works now
 o centered icon pixmap in icon with NO_ICON_BACKGROUND on
 o icon text is drawn with correct GC with NO_ICON_BACKGROUND on
 o icons are placed in IconBoxes better (with NO_ICON_BACKGROUND on)
 o changed icon drawing routines to ignore win->BackPixel and friends; 
   now use Scr.HiColors etc. directly

patch 5 (allanon)
 o no longer try to free a mini-pixmap except when it is actually used; 
   this fixed a BadPixmap error

patch 4 (allanon)
 o fixed loss of keybindings on restarting startmenu only (startmenu 
   would fail to appear)
 o fixed crash due to feel file not being loaded (ie keybindings not 
   being updated) on restarting startmenu (startmenu crashed AS when it 
   appeared)

patch 3 (allanon)
 o added InitLook() and InitFeel() to handle initializing (and 
   re-initializing) global look&feel variables
 o no longer remove borders on restart unless changing feel
 o no longer parse look file on restart unless look update requested
 o no longer parse feel file on restart unless feel update requested
 o no longer parse startmenu file on restart unless startmenu melt 
   requested

patch 2 (allanon)
 o fixed up NEWLOOK some more

patch 1 (allanon)
 o NEWLOOK can now read old-style look files

Guylhem Aznar
 * Various fixes


--


1.5pre6:

Guylhem Aznar

 * added some things (can't remember what, at least dirs now have a default
 icon in startmenu unless configure.h is edited)
 * fixed some config paths

Ingo Brueckl

 * fixed some config paths


--


1.5pre4:

Guylhem AZNAR
 I *did* tell I have CHANGELOGs so never mind for pre1,2,3 (module work)
 * fixed configure bugs (bpm replaced by man path)
 * added LEX & YACC to configure.in for afscript
 * fixed zombie afscript on exit
 * made autodetection more complete, fixed @share_dir@ in afterstep/ files
 * fixed pager bug
 * added killmodulebyname

Michal Vitecek (M.Vitecek@sh.cvut.cz)
 o fixed few memory leaks and added forgotten&overlooked assigments

patch 13 (allanon)
  o free sticky pixmap cache

patch 12 (allanon)
  o fixed pixmap caching bug; with gradient mode 2 & 3, needed to ignore 
    pixmap cache when window is wider than display

patch 11 (allanon)
  o fixed styles-related font bugs (changed Scr.StdFont and Scr.WindowFont 
    to appropriate style font)

patch 10 (allanon)
  o Wharf: move wharf windows to account for missing border (see patch 8)

patch 9 (allanon)
  o Wharf: only shape when needed, instead of always

patch 8 (allanon)
  o NoHandles now removes window borders entirely, instead of leaving a 
    one pixel border

patch 7 (allanon)
  o fixed title button redraw

patch 6 (allanon)
  o Wharf: fix bad drawable bug WRT patch 5

patch 5 (allanon)
  o Wharf: can now be shaped

patch 4 (allanon)
  o Wharf: now allow buttons to have arbitrary sizes; note that they 
    will be resized to fit in the direction of the minor axis
  o Wharf: removed Swallow, changed MaxSwallow to Swallow
  o Wharf: added new MaxSwallow, which resizes the button to fit the 
    app being swallowed.
  o Wharf: added Size keyword; should be followed by width and height 
    (ie, "Size 80 80"); will resize button to that size, ignoring all 
    other size determinations
  o Wharf: two copies of the same app can now be swallowed; 
    WARNING: the button they will be swallowed by cannot be determined 
    in advance!
  o Wharf: changed ordering of buttons; the last button on the wharf is 
    now the button farthest from the corner from which the wharf opened; 
    the last button in a subfolder is the button farthest from its 
    parent folder

patch 3 (allanon)
  o added a new function, PasteSelection, which pastes the current X 
    cutbuffer to the focused window (if any)

patch 2 (allanon)
  o added context to MenuRoot struct and made sure aw was set properly, 
    so that window menus would work
  o removed debug stuff from menus.c

patch 1 (allanon)
  o I18N font loading moved to load_font(); can we unload I18N fonts 
    with the old code?
  o Scr.EntryHeight is no longer used (which is good, as the menus are 
    dynamically sized)
  o Keyboard_shortcuts() now takes the distance to move using cursor 
    keys as a parameter; most calls now use 20 for this distance (with 
    the notable exception of the menu handler), was Scr.EntryHeight


--


1.5pre0:

Guylhem AZNAR <guylhem@oeil.qc.ca>
Well, I don't like keeping CHANGELOGs up to date :-), but :
* changed configure methods
* changed a bit Imakefile (look for radio ...)
* removed "bottomofpage" menu feature (down align menus when on botton) to
  go with Ethan patches
* Applyied M. V. patch to fix memory leaks & make shade != sticky
* Applyied all previous E. F. patches
* Created a nice Zharf default configuration
* Updated TODO
* 2-days-fight against some coredumping feature


--


patch 7:
by Ethan Fischer <allanon@u.washington.edu>
  o added mini-pixmaps to menus; to use, place a second line in the 
    menu item file containing "MiniPixmap pixmap.xpm"; this pixmap may 
    have a mask
  o MenuArrow may now have a mask

patch 6 (1.4.5.55N6) (5/25/98):
by Ethan Fischer <allanon@u.washington.edu>
  o reworked menu event handling completely again; these rules should 
    now be followed:
    o on button release in title, menu becomes pinned to the desktop
    o on button press in title of pinned menu, menu can be moved; if 
      the menu is _not_ moved, the menu is closed
  o keyboard control works again
  o pinned menus are always on top (above ONTOP windows)
  o Wharf: duplicate entries are removed before pixmaps are parsed; 
    this allows pixmaps to be specified on any of a button's lines
  o added (#ifdef guarded) mem allocation watcher; if on, displays 
    memory alloced but not freed when afterstep quits; requires use 
    of safemalloc
  o oops, changed a calloc in add_window that caused the top window 
    to be unmapped sometimes; changed it back; there shouldn't be 
    any other such bugs, as all other allocs were malloc, and malloc 
    and safemalloc are interchangeable

patch 5:
by Ethan Fischer <allanon@u.washington.edu>
  o added MenuRoot.is_pinned; when True, the menu should be pinned to 
    the desktop
  o removed MenuMode; instead, the mode is MWAIT if the menu is not 
    pinned; else the mode is (approximately) MCLICK
  o menus become pinned when the mouse button is released in the title, 
    and the menu is not transient
  o menus become unpinned on a buttonpress

patch 4.5:
by Ethan Fischer <allanon@u.washington.edu>
  o first_menu added to Scr
  o MenuRoot.next is now set, and used
  o added MenuRoot.is_transient; when True, the menu will be unable to 
    transfer to MCLICK; also will be deleted on ButtonRelease
  o WindowList menu is transient
  o added DeleteMenuRoot()
  o menus no longer use their own event loop; instead, events in menus 
    are sent to the menu from DispatchEvent(); this allows sticky menus 
    in MCLICK mode
  o made lots of other small changes to menus.c
  o keyboard control of menus is broken

patch 4 (afwharf 1.4.5.55N3):
by Ethan Fischer <allanon@u.washington.edu>
  o Wharf: fixed bug introduced in the last patch; the main wharf window 
    now positions correctly (oops!)
  o Wharf: now ignores empty folders in config (instead of crashing with 
    a BadWindow)
  o Wharf: now ignores an attempt to close the root folder in config 
    (instead of segfaulting)
  o Wharf: now closes down properly, so swallowed apps in subfolders get 
    sent a delete message
  o Wharf: only grabs button 1 from swallowed apps if the button is a 
    folder
  o Wharf: only grabs button 3 from swallowed apps if the button is in 
    the root folder
  o Wharf: only withdraws if button 3 is pressed in the root folder 
    (instead of any folder)
  o Wharf: reparents swallowed windows to IconWin, so buttons with a 
    swallowed app can use the full push animation
  o Wharf: fixed bug in transfer to withdrawn state; the pointer coords 
    are now translated to the root_folder window (not the Root window); 
    should withdraw to the right corner now

patch 3 (afwharf 1.4.5.55N2):
by Ethan Fischer <allanon@u.washington.edu>
  o menu title & item text is drawn in the correct font (WindowFont, Font)
  o Wharf: now uses XGetGeometry on maxswallowed windows instead of assuming 
    that they will be 55x57
  o Wharf: now only grabs buttons 1 & 3 from swallowed apps, instead of all 
    buttons
  o Wharf: removed the Buttons and Folders arrays, and replaced them with 
    linked lists
  o Wharf: can swallow to a button inside a folder
  o Wharf: folders can have subfolders. this is done the obvious way; just 
    nest the Folder/~Folder statements
  o Wharf: added MapNotify handler to make sure that folders are unmapped 
    when they are supposed to be

patch 2 (1.4.5.55N) (5/13/98):
by Ethan Fischer <allanon@u.washington.edu>
  o previous patch to DrawMenuBorders is backed out
  o when the option "DrawMenuBorders" is off, the menu no longer has any 
    border, filling the empty spaces that were still there
  o added a new option, "TextureMenuItemsIndividually". scary name, but 
    cool feature: when it is off, the entire menu will be textured, not 
    each menu item individually. this was done by DrawMenuBorders == 0 
    previously, but that was non-obvious - hence the new keyword
  o some variables that were not being initialized on restart now are. in 
    particular: Textures.flags, DrawMenuBorders,
    TextureMenuItemsIndividually, DrawTitleTextBackground, Xzap, Yzap,
    AutoReverse
  o added new keywords to allow better control over menu colors; this
    required adding another option to TextureTypes and TextureMaxColors
    MTitleForeColor: menu title foreground color (was HiForeColor)
    MTitleBackColor: menu title background color (was HiBackColor)
    MenuHiForeColor: selected item foreground color (was MenuForeColor)
    MenuHiBackColor: selected item background color (was HiForeColor)
    MenuHiTextureColor: selected item background gradient (was
	MenuTextureColor)
    MenuHiPixmap: selected item background pixmap (was MenuPixmap)
  o added my_sort to homeanddirs.c. to use, setup the null-terminated array 
    my_sort_list, which will be evaluated in descending order
  o added my_dirsort, which sorts by type
  o added comment to NewCheckOrShare, changed sizeof(char*) to sizeof(char), 
    and changed malloc to safemalloc
  o check_allowed_function now returns False on F_NOP; this results in F_NOP 
    items being stippled; since they can't do anything anyway, this is 
    probably okay
  o F_NOP is put in the menu, even if its item text has zero length. this 
    allows the next feature:
  o a separator is drawn in menus if the function is F_NOP, the item 
    text has zero length, and DrawMenuBorders is 0 (it looks pretty bad if 
    DrawMenuBorders is 1)
  o general overhaul to PaintEntry; menus now look like they should WRT 
    DrawMenuBorders and TextureMenuItemsIndividually
  o made local variable in CheckOrShare static, so that it can be safely 
    returned
  o removed redundant UpdateStartMenu keyword. this functionality is also 
    available by "QuickRestart startmenu". look&feel should probably be 
    updated this way as well
  o modified Quit menu to remove quotes which were preventing several menu 
    items from working
  
patch 1:
by Ethan Fischer <allanon@u.washington.edu>
  o NewCheckOrShare added. it returns just the path, not the path + directory
  o SearchIcon defaults to tmp_win->icon_bitmap_file, so default icons work
  o UpdateMenu remembers Tmp_win, so menus don't forget that the "Quit" 
    option should be stippled
  o stippled menu items can no longer be selected
  o MeltStartMenu changed significantly:
   o all submenus are given a unique ID, so they cannot be confused (eg, 
     two copies of the "Games" submenu)
   o if the first word of a file is a reserved word (eg, "Restart"), the 
     file contents are passed through unmodified. the contents of such 
     a file *must* be a complete, valid line for the config file, or 
     AfterStep will exit with an error
   o the "Start" menu is treated just like its subdirectories, except for 
     the name (which is not given an ID)
   o the hardcoded "Desktop", "Modules", and "Quit" menus are removed
   o the "Look", "Feel", and "Pictures" submenus are still hardcoded, 
     however. to place them in the menu, just make an empty subdir with 
     the appropriate name, and it will automagically be filled in
  o menus now scroll

patch 0:
by Ethan Fischer <allanon@u.washington.edu>
  o when the option "DrawMenuBorders" is off, the entire menu will be
    textured


--
